(**************************************************************************
* BlockCAD, a program for building with Lego like blocks on the computer
* Copyright (C) 1998  Anders Isaksson
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
* -------------------------------------------------------------------------
* I hope You send me a copy of any important changes/additions You do.
*
* E-mail: isaksson.etuna@ebox.tninet.se
*
**************************************************************************)

unit askfp;

interface

uses
  Windows, StdCtrls, Buttons, Controls, Classes, Forms, Dialogs
  ;

type
  TAskFileAndPart = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    Label3: TLabel;
    Label4: TLabel;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
    function GetFNam: string;
    function GetPNam: string;
    function GetLEGOid: string;
    function GetAuthor: string;
    procedure SetFNam(s: string);
    procedure SetPNam(s: string);
    procedure SetLEGOid(s: string);
    procedure SetAuthor(s: string);
  public
    { Public declarations }
    property FileName: string read GetFnam write SetFnam;
    property PartName: string read GetPnam write SetPnam;
    property LEGOid: string read GetLEGOid write SetLEGOid;
    property Author: string read GetAuthor write SetAuthor;
  end;

var
  AskFileAndPart    : TAskFileAndPart;

implementation

{$R *.DFM}

function TAskFileAndPart.GetFNam: string;
begin
  Result := Edit1.Text;
end;

function TAskFileAndPart.GetPNam: string;
begin
  Result := Edit2.Text;
end;

function TAskFileAndPart.GetLEGOid: string;
begin
  Result := Edit3.Text;
end;

function TAskFileAndPart.GetAuthor: string;
begin
  Result := Edit4.Text;
end;

procedure TAskFileAndPart.SetFNam(s: string);
begin
  Edit1.Text := s;
end;

procedure TAskFileAndPart.SetPNam(s: string);
begin
  Edit2.Text := s;
end;

procedure TAskFileAndPart.SetLEGOid(s: string);
begin
  Edit3.Text := s;
end;

procedure TAskFileAndPart.SetAuthor(s: string);
begin
  Edit4.Text := s;
end;

procedure TAskFileAndPart.Button1Click(Sender: TObject);
begin
  if (Length(Edit1.Text) = 0) or (Length(Edit2.Text) = 0) then begin
    ShowMessage('Filename and Partname must be entered');
    ModalResult := mrNone;
  end;
end;

end.
