(**************************************************************************
* BlockCAD, a program for building with Lego like blocks on the computer
* Copyright (C) 1998,1999,2000  Anders Isaksson
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
* -------------------------------------------------------------------------
* I hope You send me a copy of any important changes/additions You do.
*
* E-mail: isaksson.etuna@ebox.tninet.se
*
**************************************************************************)

unit Main;

{ Perspective is commented out, because it doesn't work very well at all  }
{ Rotate in viewing plane is commented out, doesn't work very well        }
{ The problem is all the shortcuts taken when drawing - all points are    }
{ not transformed/computed in the same coordinate system! (Especially     }
{ studs)                                                                  }

interface

uses
  Windows, Dialogs, Menus, ExtCtrls, StdCtrls, BgPanel,
  TB97Ctls, TB97Tlbr, Controls, TB97, Classes, Messages, Forms,
  Graphics, LCadPc2, ImgList, RxMenus, DrawObject, ExtDlgs, Buttons
  ;

const
  REALLY_STARTED    = WM_USER + 164;
  REDRAW_PICTURE    = WM_USER + 165;

type

  TResolution = (rNormal, rHalf, rFine);
  TOpenMode = (omNewModel, omSubAssembly, omBreakUp);

  TMainForm = class(TForm)
    Panel2: TBgPanel;
    Panel3: TBgPanel;
    RotX: TScrollBar;
    RotZ: TScrollBar;
    ListBox1: TListBox;
    edWhite: TEdit;
    edGray: TEdit;
    edDarkGray: TEdit;
    edBlack: TEdit;
    Edit6: TEdit;
    Edit7: TEdit;
    edBlue: TEdit;
    Edit9: TEdit;
    OpenDialog1old: TOpenDialog;
    dlgSaveFile: TSaveDialog;
    Edit1: TEdit;
    Edit10: TEdit;
    Edit11: TEdit;
    Edit12: TEdit;
    Edit13: TEdit;
    Edit14: TEdit;
    PrintDialog1: TPrintDialog;
    ScaleBar: TScrollBar;
    RotY: TScrollBar;
    btnPrevPage: TToolbarButton97;
    btnNextPage: TToolbarButton97;
    pumOptions: TPopupMenu;
    mSafePos: TMenuItem;
    mSlowRender: TMenuItem;
    Panel8: TPanel;
    OffsetX: TScrollBar;
    btnHome: TToolbarButton97;
    Panel9: TPanel;
    OffsetY: TScrollBar;
    mRestBg: TMenuItem;
    mHideStuds: TMenuItem;
    dlgSavePicture: TSaveDialog;
    pumEdit: TPopupMenu;
    Editblock1: TMenuItem;
    Addnewblock1: TMenuItem;
    Removeblock1: TMenuItem;
    Addnewpage1: TMenuItem;
    Removepage1: TMenuItem;
    N1: TMenuItem;
    pumLoad: TPopupMenu;
    mSubAssembly: TMenuItem;
    mNewmodel: TMenuItem;
    N3: TMenuItem;
    PopupMenu4: TPopupMenu;
    LDrawthisview1: TMenuItem;
    N5: TMenuItem;
    ColorDialog1: TColorDialog;
    Advancedtoolbox1: TMenuItem;
    N4: TMenuItem;
    miGroup: TMenuItem;
    miBreak: TMenuItem;
    N6: TMenuItem;
    L2pov: TMenuItem;
    L3pov: TMenuItem;
    ComboBox1: TComboBox;
    pumSave: TPopupMenu;
    mSaveModel: TMenuItem;
    mSaveSelected: TMenuItem;
    N7: TMenuItem;
    Hints1: TMenuItem;
    Backgroundpicture1: TMenuItem;
    Customize1: TMenuItem;
    Properties1: TMenuItem;
    Addpagefromfile1: TMenuItem;
    OpenDialog2: TOpenDialog;
    Reorderpages1: TMenuItem;
    N9: TMenuItem;
    Dock971: TDock97;
    Dock972: TDock97;
    Dock973: TDock97;
    Dock974: TDock97;
    Toolbar971: TToolbar97;
    Toolbar972: TToolbar97;
    ExitButton: TToolbarButton97;
    btnClear: TToolbarButton97;
    btnOpen: TToolbarButton97;
    btnSave: TToolbarButton97;
    btnSavePic: TToolbarButton97;
    btnPrint: TToolbarButton97;
    btnSettings: TToolbarButton97;
    btnPointer: TToolbarButton97;
    btnTransparent: TToolbarButton97;
    btnPieceStuds: TToolbarButton97;
    btnColorDlg: TToolbarButton97;
    btnAbout: TToolbarButton97;
    ToolbarSep973: TToolbarSep97;
    ToolbarSep975: TToolbarSep97;
    Toolbar973: TToolbar97;
    Toolbar974: TToolbar97;
    Label1: TLabel;
    BSizeX: TEdit97;
    Label3: TLabel;
    BSizeY: TEdit97;
    ThickBase: TToolbarButton97;
    ToolbarSep976: TToolbarSep97;
    btnTopView: TToolbarButton97;
    btnFromFront: TToolbarButton97;
    btnFromRight: TToolbarButton97;
    btnFromLeft: TToolbarButton97;
    btnFromBack: TToolbarButton97;
    btnFrontLeft: TToolbarButton97;
    btnBackLeft: TToolbarButton97;
    btnBackRight: TToolbarButton97;
    btnFrontRight: TToolbarButton97;
    btnFrontView: TToolbarButton97;
    btnRestoreView: TToolbarButton97;
    cbResolution: TComboBox;
    lblZLiftOff: TLabel;
    ToolbarSep977: TToolbarSep97;
    ZLiftOff: TScrollBar;
    ToolbarSep978: TToolbarSep97;
    Toolbar975: TToolbar97;
    btnRotLeft: TToolbarButton97;
    btnRotUp: TToolbarButton97;
    btnRotDown: TToolbarButton97;
    btnRotRight: TToolbarButton97;
    ToolbarSep972: TToolbarSep97;
    btnStuds: TToolbarButton97;
    btnWireFrame: TToolbarButton97;
    btnWireBase: TToolbarButton97;
    ToolbarSep974: TToolbarSep97;
    btnZoomIn: TToolbarButton97;
    btnZoomOut: TToolbarButton97;
    btnRefresh: TToolbarButton97;
    Breakupascene1: TMenuItem;
    N10: TMenuItem;
    ImageList1: TImageList;
    Addcombo1: TMenuItem;
    pumStuds: TPopupMenu;
    FastStuds2: TMenuItem;
    BetterStuds2: TMenuItem;
    BestStuds2: TMenuItem;
    Nostuds2: TMenuItem;
    pumDetail: TPopupMenu;
    miNoDetail: TMenuItem;
    miMoreDetail: TMenuItem;
    miMostDetail: TMenuItem;
    N2: TMenuItem;
    miShading: TMenuItem;
    miAdjustLight: TMenuItem;
    ImageList2: TImageList;
    N8: TMenuItem;
    miSeeThroughBP: TMenuItem;
    PaintBox1: TPaintBox;
    Boundary1: TMenuItem;
    miTiming: TMenuItem;
    OpenPictureDialog1: TOpenPictureDialog;
    miWfOnMouseRot: TMenuItem;
    BitDepth1: TMenuItem;
    pf8bit1: TMenuItem;
    pf16bit1: TMenuItem;
    pf24bit1: TMenuItem;
    pf32bit1: TMenuItem;
    pfdevice1: TMenuItem;
    N11: TMenuItem;
    Sequencer1: TMenuItem;
    btnRedo: TToolbarButton97;
    btnUndo: TToolbarButton97;
    miAntiAlias: TMenuItem;
    Edit2: TEdit;
    Edit3: TEdit;
    miEditID: TMenuItem;
    procedure PaintBox1Paint(Sender: TObject);
    procedure RotXChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure PaintBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure PaintBox1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure RedrawPicture(Sender: TObject);
    procedure ScaleBarChange(Sender: TObject);
    procedure OffsetXChange(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure btnHomeClick(Sender: TObject);
    procedure RadioGroup1Click(Sender: TObject);
    procedure btnRotLeftClick(Sender: TObject);
    procedure btnRotUpClick(Sender: TObject);
    procedure btnRotDownClick(Sender: TObject);
    procedure btnRotRightClick(Sender: TObject);
    procedure ExitButtonClick(Sender: TObject);
    procedure btnPointerClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ListBox1Click(Sender: TObject);
    procedure BSizeXKeyPress(Sender: TObject; var Key: Char);
    procedure ThickBaseClick(Sender: TObject);
    procedure btnClearClick(Sender: TObject);
    procedure ZLiftOffChange(Sender: TObject);
    procedure btnPieceStudsClick(Sender: TObject);
    procedure btnPrintClick(Sender: TObject);
    procedure ListBox1DrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
    procedure ListBox1MeasureItem(Control: TWinControl; Index: Integer;
      var Height: Integer);
    procedure btnPrevPageClick(Sender: TObject);
    procedure btnNextPageClick(Sender: TObject);
    procedure Edit7MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure btnRestoreViewClick(Sender: TObject);
    procedure TransparentMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure btnZoomInClick(Sender: TObject);
    procedure btnZoomOutClick(Sender: TObject);
    procedure btnRefreshClick(Sender: TObject);
    procedure btnRotCLWClick(Sender: TObject);
    procedure btnRotCCLWClick(Sender: TObject);
    procedure mSafePosClick(Sender: TObject);
    procedure mSlowRenderClick(Sender: TObject);
    procedure mRestBgClick(Sender: TObject);
    procedure mHideStudsClick(Sender: TObject);
    procedure btnAboutClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ListBox1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Addnewblock1Click(Sender: TObject);
    procedure Removeblock1Click(Sender: TObject);
    procedure pumEditPopup(Sender: TObject);
    procedure Editblock1Click(Sender: TObject);
    procedure Addnewpage1Click(Sender: TObject);
    procedure Removepage1Click(Sender: TObject);
    procedure FastStuds1Click(Sender: TObject);
    procedure mNewmodelClick(Sender: TObject);
    procedure mSubAssemblyClick(Sender: TObject);
    procedure Panel2MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SpeedButton1Click(Sender: TObject);
    procedure btnColorDlgClick(Sender: TObject);
    procedure Advancedtoolbox1Click(Sender: TObject);
    procedure NoDetailsClick(Sender: TObject);
    procedure pumOptionsPopup(Sender: TObject);
    procedure miGroupClick(Sender: TObject);
    procedure miBreakClick(Sender: TObject);
    procedure L2povClick(Sender: TObject);
    procedure L3povClick(Sender: TObject);
    procedure ComboBox1DropDown(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure mSaveModelClick(Sender: TObject);
    procedure mSaveSelectedClick(Sender: TObject);
    procedure pumSavePopup(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure pumLoadPopup(Sender: TObject);
    procedure Hints1Click(Sender: TObject);
    procedure miShadingClick(Sender: TObject);
    procedure miAdjustLightClick(Sender: TObject);
    procedure btnSavePicClick(Sender: TObject);
    procedure Backgroundpicture1Click(Sender: TObject);
    procedure Customize1Click(Sender: TObject);
    procedure Properties1Click(Sender: TObject);
    procedure Addpagefromfile1Click(Sender: TObject);
    procedure Reorderpages1Click(Sender: TObject);
    procedure cbResolutionChange(Sender: TObject);
    procedure PaintBox1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Breakupascene1Click(Sender: TObject);
    procedure Addcombo1Click(Sender: TObject);
    procedure Nostuds1Click(Sender: TObject);
    procedure RxPopupMenu1DrawItem(Sender: TMenu; Item: TMenuItem;
      Rect: TRect; State: TMenuOwnerDrawState);
    procedure btnWireFrameClick(Sender: TObject);
    procedure miSeeThroughBPClick(Sender: TObject);
    procedure Boundary1Click(Sender: TObject);
    procedure miTimingClick(Sender: TObject);
    procedure miWfOnMouseRotClick(Sender: TObject);
    procedure pfdevice1Click(Sender: TObject);
    procedure Sequencer1Click(Sender: TObject);
    procedure btnUndoClick(Sender: TObject);
    procedure btnRedoClick(Sender: TObject);
    procedure miAntiAliasClick(Sender: TObject);
    procedure miEditIDClick(Sender: TObject);
    procedure FormMouseWheelDown(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: Boolean);
    procedure FormMouseWheelUp(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: Boolean);
  private
    { Private declarations }
    SettingsSlow: Boolean;
    SettingsSafe: Boolean;
    Recent: TStringList;
    RecentCl: TList;
    RcHeight: integer;
    LDrawLib: string;
    LDrawProg: string;
    LDrawTest: string;
    L2PCmd: string;
    L3PCmd: string;
    PovRayEng: string;
    Colors: array[0..13] of TEdit;
    BackGround: TBitMap;
    BackGroundFile: string;
    LoadLGOPath,
      SaveLGOPath,
      LoadSASPath,
      SaveSASPath,
      SaveBMPPath,
      LoadBGRPath: string;
    LastX,
      LastY,
      LastZ: integer;
    fIniFile: string;
    fStartModelFile: string;
    function ScreenCoord(const p: TPoint3D; const d: integer): TPoint;
    procedure OnHint(Sender: TObject);
    procedure ClearCursorPiece;
    procedure RedrawCursorPiece;
    procedure SetCursorPiece(const x, y: integer);
    procedure SetUpNewPiece(const NewBlock: TObject);
    function ZLevel(const Pxx, Pyy, Pll, Pbb: integer): integer;
    procedure ScreenXYTo3D(const sx, sy: integer; var xx, yy, zz: integer; const ll, bb: integer);
    procedure SetView(x, z: integer);
    procedure SetCurrentPage(n: integer);
    procedure SetCurrentFile(f: string);
    //    procedure CalcEye;                  { For perspective view }
    procedure WriteToIni(IniFile: string);
    procedure SaveAsLDraw(var f: TextFile);
    function ColorMatch(c: TColor): integer;
    function FirstSelected: integer;
    function NextSelected(const b: integer): integer;
    function FirstInGroup(const g: integer): integer;
    function NextInGroup(const g, b: integer): integer;
    function SaveFile(var Path: string; SaveAll: Boolean): Boolean;
    procedure UpdateBC2LDList(Old, New: string);
    procedure SavePicture(const Quality: integer);
    procedure FillPageFromFile(FileName: string; PageNo: integer);
    procedure DrawCamera;
    procedure AntiAliasDraw(const Bitmap: TBitmap; const CameraRect: TRect;
      const Width, Height: integer);
    procedure PlacePiece(var lg: integer);
    procedure LargeBmpDraw(const BigBitmap: TBitmap;
      const CameraRect: TRect; const Factor: integer);
    procedure ScanStartParams;
    procedure SetBitDepth(Depth: integer);
    procedure CenterInDisplay;
  protected
    procedure msgReallyStarted(var msg: TMessage); message REALLY_STARTED;
    procedure msgRedrawPicture(var msg: TMessage); message REDRAW_PICTURE;
    procedure OpenNamedFile(FileName: string; Mode: TOpenMode);
    procedure MRUClick(Sender: TObject);
    function CheckModified: boolean;
  public
    { Public declarations }
    ColorIndicator: TColor;
    PageNames: TStringList;
    Pages: TStringList;
    PgHeight: TList;
    PgScale: TList;
    CurPage: integer;
    Resolution: TResolution;
    ResXYFact, ResZFact: integer;
    WireBase, WireFrame: Boolean;
    procedure RefreshListBox;
    procedure SetStudsIncrement;
    procedure SetBase;
    function OpenFile(t: string; Mode: TOpenMode): boolean;
    function ColorMatch2(c: integer): TColor;
    procedure FindCenter(var bx0, by0, bz0, bx1, by1, bz1, cx, cy, cz: integer);
    procedure CuttingDlgChange(Sender: TObject);
    procedure DrawScene;
  end;

type
  TLDrawRecord = class
    t: char;
    b: integer;
    l: integer;
    h: integer;
    st: integer;
    cl: integer;
    xOffset: integer;
    yOffset: integer;
    zOffset: integer;
    RotOffset: integer;
    PartId: string;
    LDrawPAtch: integer;
    FilNam: string;
    PrtNam: string;
  end;

type
  TSettings = record
    Scale: TMyFloat;
    xBase,
      yBase: TMyFloat;
    RotXPos,
      RotZPos,
      ScaleBarPos,
      OffsetXPos,
      OffsetYPos: integer;
    StudsDown: Boolean;
    Time: TMyFloat;
    Frames: integer;
  end;

var
  MainForm          : TMainForm;
  Piece             : TBlock;
  Settings          : TSettings;
  NoRedraw          : Boolean;
  InternalNoRedraw  : Boolean;
  InternalNoRedrawListBox: Boolean;
  BlockList         : TBlockList;
  Macro             : TBlockList;
  LoadingMacro      : Boolean;
  BlackColor,
    BlueColor,
    GrayColor,
    RedColor,
    LineColorD,
    LineColorL,
    LineColorB,
    SelColor        : TColor;
  SelEdge           : TColor;
  NextGroup         : integer;
  LDrawCross        : TStringList;
  BitDepth          : TPixelFormat;
  //  Eye               : TPoint3D;         { For perspective view}

procedure Transform(const p: array of TPoint3D; var Pts: array of TPoint; Dir: integer);
function Max(const a, b: integer): integer;
function Min(const a, b: integer): integer;
function CreateBlockFromString(s: string): TBlock;
procedure InitializeLDrawCross;
function CrossStringFromData(d: TLDrawRecord): string;
procedure SaveLDrawCross;
function InvColorMatch(c: integer): TColor;
function NextInt(const s: string; var i: integer; const d: integer): integer;
function NextString(const s: string; var i: integer; const d: string): string;

const
  DEG2RAD           = pi / 180.0;

const
  ZCutOff           : integer = 9999;

type
  TMatchColor = record
    R, G, B: byte;
    LDColor: word;
    Name: string[15];
  end;

var
  MatchColor        : array[0..25] of TMatchColor = (
    {0}(R: 27; G: 42; B: 52; LDColor: 0; Name: 'Black'),
    {1}(R: 35; G: 71; B: 139; LDColor: 1; Name: 'Blue'),
    {2}(R: 75; G: 151; B: 74; LDColor: 2; Name: 'Green'),
    {3}(R: 40; G: 127; B: 70; LDColor: 3; Name: 'Dark Cyan'),
    {4}(R: 196; G: 40; B: 27; LDColor: 4; Name: 'Red'),
    {5}(R: 255; G: 45; B: 159; LDColor: 5; Name: 'Magenta'),
    {6}(R: 105; G: 64; B: 39; LDColor: 6; Name: 'Brown'),
    {7}(R: 161; G: 165; B: 162; LDColor: 7; Name: 'Grey'),
    {8}(R: 109; G: 110; B: 108; LDColor: 8; Name: 'Dark grey'),
    {9}(R: 85; G: 164; B: 249; LDColor: 9; Name: 'Light blue'),
    {10}(R: 161; G: 196; B: 139; LDColor: 10; Name: 'Light green'),
    {11}(R: 193; G: 233; B: 240; LDColor: 11; Name: 'Cyan'),
    {12}(R: 218; G: 134; B: 121; LDColor: 12; Name: 'Light red'),
    {13}(R: 238; G: 196; B: 182; LDColor: 13; Name: 'Pink'),
    {14}(R: 245; G: 205; B: 47; LDColor: 14; Name: 'Yellow'),
    {15}(R: 242; G: 243; B: 242; LDColor: 15; Name: 'White'),

    {16}(R: 255; G: 255; B: 255; LDColor: 0; Name: '???'),
    {17}(R: 194; G: 218; B: 184; LDColor: 17; Name: 'Pastel Green'),
    {18}(R: 243; G: 207; B: 155; LDColor: 18; Name: 'Light Yellow'),
    {19}(R: 249; G: 233; B: 153; LDColor: 19; Name: 'Tan'),
    {20}(R: 215; G: 196; B: 230; LDColor: 20; Name: 'Light purple'),
    {21}(R: 224; G: 255; B: 176; LDColor: 21; Name: 'Gold'),
    {22}(R: 122; G: 37; B: 143; LDColor: 22; Name: 'Purple'),
    {23}(R: 35; G: 71; B: 139; LDColor: 23; Name: 'Purple Blue'),
    {24}(R: 204; G: 204; B: 204; LDColor: 383; Name: 'Chrome'),
    {25}(R: 218; G: 133; B: 64; LDColor: 25; Name: 'Orange')
    );
  (* 43,
  *)
implementation

uses
  IniFiles, SysUtils, Printers, Math, Jpeg, pngimage,
  AboutBLK, Advanced, AddStd, SetLight, Custmize, CEJUtils, Proprtys,
  LCadGnrl, LCadPc1, Reorder, FileCtrl, LDrawSupport, OpenModel,
  Cutting, OpenModelDialog, Sequencer, CameraSize, EditID
  ;

{$R *.DFM}
{$R tt.res}

var
  mx, my            : integer;
  Shadow            : TBitmap;
  WorkBmp           : TBitmap;
  LstBmp            : TBitmap;
  JustOne           : Boolean;
  Modified          : Boolean;
  MRUList           : TStringList;

type
  TCameraState = (cmsActive, cmsMove, cmsSizeN, cmsSizeE, cmsSizeS, cmsSizeW);

var

  Camera            : record
    r: TRect;
    h: Trect;
    rx, rmax, rmin, ro, ra, r2, r4, r8, tx: TRect;
    State: set of TCameraState;
  end;

  (*
  0 ##### Code  Name         Edge    Red Grn Blu Alpha Red Grn Blu Alpha
  0 COLOR  0    black        8        33  33  33 255    33  33  33 255
  0 COLOR  1    blue         0         0  51 178 255     0  51 178 255
  0 COLOR  2    green        0         0 144  58 255     0 144  58 255
  0 COLOR  3    teal         0         0 166 168 255     0 166 168 255
  0 COLOR  4    red          0       196   0  38 255   196   0  38 255
  0 COLOR  5    magenta      0       255  45 149 255   255  45 149 255
  0 COLOR  6    brown        8       102  58  34 255   102  58  34 255
  0 COLOR  7    gray         0       193 194 193 255   193 194 193 255
  0 COLOR  8    dark-gray    0        99  95  82 255    99  95  82 255
  0 COLOR  9    light-blue   0         0 119 232 255     0 119 232 255
  0 COLOR 10    bright-green 0         0 191  89 255     0 191  89 255
  0 COLOR 11    turquoise    0        85 164 249 255    85 164 249 255
  0 COLOR 12    salmon       4       255 133 122 255   255 133 122 255
  0 COLOR 13    pink         0       249 164 198 255   249 164 198 255
  0 COLOR 14    yellow       0       255 220 0   255   255 220   0 255
  0 COLOR 15    white        0       255 255 255 255   255 255 255 255
  0 COLOR 17    mint-green   0       107 238 144 255   107 238 144 255
  0 COLOR 18    light-yellow 0       243 238 124 255   243 238 124 255
  0 COLOR 19    tan          6       247 231 173 255   247 231 173 255
  0 COLOR 20    light-purple 0       215 196 230 255   213 221 238 255
  0 COLOR 21    glowinthedrk 65      224 255 176 255   224 255 176 196
  0 COLOR 65    GITD-Edge    21      118 192   0 255   118 192   0 255
  0 COLOR 22    purple       0       122  37 143 255   122  37 143 255
  0 COLOR 23    bluishviolet 0        71  50 176 255    71  50 176 255
  0 COLOR 25    orange       0       249  96   0 255   249  96   0 255
  0 COLOR 33    trans-blue   66        0  32 160 255     0   0   0   0
  0 COLOR 66    blue-edge    1         0  27  96 255     0  27  96 255
  0 COLOR 34    trans-green  67        0 135  64 255     0   0   0   0
  0 COLOR 67    green-edge   2         0  64  30 255     0  64  30 255
  0 COLOR 36    trans-red    68      196   0  38 255     0   0   0   0
  0 COLOR 68    red-edge     4        96   0  18 255    96   0  18 255
  0 COLOR 39 trans-gray      0        99  95  82 255     0   0   0   0
  0 COLOR 41 trans-light-blue 0      174 239 236 255     0   0   0   0
  0 COLOR 42 trans-neon-green 0      192 255   0 255     0   0   0   0
  0 COLOR 46 trans-yellow    0       255 220   0 255     0   0   0   0
  0 COLOR 47 clear           0       255 255 255 255     0   0   0   0
  0 COLOR 57 trans-orange    0       249  96   0 255     0   0   0   0
  0 COLOR 335 sand-red       0       210 152 146 255   210 152 146 255
  0 COLOR 378 sand-green     0        94 154 128 255    94 154 128 255
  0 COLOR 377 sand-blue      0       106 122 150 255   106 122 150 255
  0 COLOR 373 sand-violet    0       132  94 132 255   132  94 132 255
  0 COLOR 320 darkred        0       120   0  28 255   120   0 28  255
  *)

function IntToFloat(const i: integer): TMyFloat;
begin
  Result := i;
end;

function Max(const a, b: integer): integer;
begin
  if a > b then
    Result := a
  else
    Result := b
end;

function rMax(const a, b: TMyFloat): TMyFloat;
begin
  if a > b then
    Result := a
  else
    Result := b
end;

function Min(const a, b: integer): integer;
begin
  if a < b then
    Result := a
  else
    Result := b
end;

function Sign(const v: integer): integer;
begin
  if v < 0 then
    Result := -1
  else if v > 0 then
    Result := 1
  else
    Result := 0;
end;

{$IFDEF VER80}

function Floor(const x: TMyFloat): integer;
begin
  if x < 0 then
    Result := -Trunc(-x) - 1
  else
    Result := Trunc(x);
end;

function Trim(const s: string): string;
begin
  Result := s;
  while (Length(Result) > 0) and (Result[1] = ' ') do
    System.Delete(Result, 1, 1);
end;
{$ENDIF}

procedure TMainForm.SetStudsIncrement;
begin
  xf := Round(5.0 * Settings.Scale);
  yf := Round(5.0 * Settings.Scale * Cx);
  xf2 := (xf) div 2;
  yf2 := (yf) div 2;
end;

(* Perspective

procedure TMainForm.CalcEye;
var
  Dist              : TMyFloat;
  rx1               : TMyFloat;
begin
  rx1 := rx;
  Dist := 4000;
  Eye.x := Round(-sin(rx1) * Dist * sin(rz));
  Eye.y := Round(sin(rx1) * Dist * cos(rz));
  Eye.z := Round(cos(rx1) * Dist);
  //  Edit16.Text := Format('%d,%d,%d', [Eye.x, Eye.y, Eye.z]);
end;
*)

function TMainForm.ScreenCoord(const p: TPoint3D; const d: integer): TPoint;
var
  x, y              : TMyFloat;
  //  dist              : TMyFloat;         { Perspective}
begin
  x := (p.x * tr00[d] + p.y * tr01[d] + p.z * tr02[d]) * Settings.Scale;
  y := -(p.x * tr10[d] + p.y * tr11[d] + p.z * tr12[d]) * Settings.Scale;

  (* Turn in viewing plane - does not work
    Result.x := Round((x * RotCos - y * RotSin) + xBase);
    Result.y := Round((y * RotCos + x * RotSin) + yBase);
  *)

  (* Perspective - does not work
  dist := sqrt(sqr(eye.x - p.x) + sqr(eye.y - p.y) + sqr(eye.z - p.z));
  if Dist > 0 then
  begin
    x := x / Dist * 1000.0;
    y := y / Dist * 1000.0;
  end;
  *)
  Result.x := Round(x + Settings.xBase);
  Result.y := Round(y + Settings.yBase);
end;

procedure Transform(const p: array of TPoint3D; var Pts: array of TPoint; Dir: integer);
var
  i                 : integer;
  fx, fy            : TMyFloat;
  //  dist              : TMyFloat;         { Perspective }
  tr00d, tr01d, tr02d, tr10d, tr11d, tr12d: TMyFloat;
  sc, sx, sy        : TMyFloat;
begin
  tr00d := tr00[Dir];
  tr01d := tr01[Dir];
  tr02d := tr02[Dir];
  tr10d := tr10[Dir];
  tr11d := tr11[Dir];
  tr12d := tr12[Dir];
  sc := Settings.Scale;
  sx := Settings.xBase;
  sy := Settings.yBase;
  for i := Low(p) to High(p) do begin
    with p[i] do begin
      fx := (x * tr00D + y * tr01D + z * tr02D) * Sc;
      fy := -(x * tr10D + y * tr11D + z * tr12D) * Sc;

      (* Turn in viewing plane - does not work
            Pts[i].x := Round((fx * RotCos - fy * RotSin) + xBase);
            Pts[i].y := Round((fy * RotCos + fx * RotSin) + yBase);
      *)

      (* Perspective - does not work
      dist := sqrt(sqr(eye.x - x) + sqr(eye.y - y) + sqr(eye.z - z));
      if Dist > 0 then begin
        fx := fx / Dist * 1000.0;
        fy := fy / Dist * 1000.0;
      end;
      *)
      Pts[i].x := Round(fx + Sx);
      Pts[i].y := Round(fy + Sy);
    end;
  end;
end;

procedure TMainForm.SetBase;
begin
  Settings.xBase := Round(PaintBox1.ClientWidth / 2.0) - OffsetX.Position;
  Settings.yBase := Round(PaintBox1.ClientHeight / 2.0) - OffsetY.Position;
end;

procedure TMainForm.WriteToIni(IniFile: string);
var
  F                 : TIniFile;
  i                 : integer;
  j                 : integer;
  Section           : string;
begin
  F := TIniFile.Create(IniFile);
  try
    try
      Section := 'Main';
      F.EraseSection(Section);
      F.WriteInteger(Section, 'Version', 2);
      F.WriteInteger(Section, 'Pages', Pages.Count);
      F.WriteString(Section, 'LDrawLib', LDrawLib);
      F.WriteString(Section, 'LDrawProg', LDrawProg);
      F.WriteString(Section, 'LDrawTest', LDrawTest);
      F.WriteString(Section, 'L2PCmd', L2PCmd);
      F.WriteString(Section, 'L3PCmd', L3PCmd);
      F.WriteString(Section, 'PovRayEng', PovRayEng);

      F.WriteString('UserPaths', 'Models', LoadLGOPath);
      F.WriteString('UserPaths', 'Pictures', SaveBMPPath);

      for i := 0 to Pred(Pages.Count) do begin
        Section := Format('Page%d', [i + 1]);
        F.EraseSection(Section);
        F.WriteString(Section, 'Title', PageNames[i + 1]);
        F.WriteInteger(Section, 'Height', integer(PgHeight[i]));
        F.WriteString(Section, 'Scale', Format('%5.2f', [single(PgScale[i])]));
        with TStringList(Pages.Objects[i]) do begin
          F.WriteInteger(Section, 'Count', Count);
          for j := 0 to Pred(Count) do begin
            F.WriteString(Section, Format('Brick%d', [j]), Strings[j]);
          end
        end
      end;
      Section := 'State';
      F.EraseSection(Section);
      F.WriteInteger(Section, 'Hints', integer(Hints1.Checked));
      F.WriteInteger(Section, 'StudQual', TBlock.GetStudQuality);
      F.WriteInteger(Section, 'Details', DetailLevel);
      F.WriteInteger(Section, 'Shading', integer(miShading.Checked));
      F.WriteInteger(Section, 'WfOnMouse', integer(miWfOnMouseRot.Checked));
      case BitDepth of
        pf8Bit: F.WriteInteger(Section, 'BitDepth', 1);
        pf16Bit: F.WriteInteger(Section, 'BitDepth', 2);
        pf24Bit: F.WriteInteger(Section, 'BitDepth', 3);
        pf32Bit: F.WriteInteger(Section, 'BitDepth', 4);
        pfDevice: F.WriteInteger(Section, 'BitDepth', 5);
      end;
    finally
      F.Free;
    end;
  except
    ;                                   // Eat exceptions silently - the .ini may be write protected
  end
end;

procedure Ver1FillFromIni(l: TStrings; IniFile, Page: string;
  var Height: integer; var Scale: single);
var
  F                 : TextFile;
  s                 : string;
  s1, s2            : string;
  p                 : integer;
begin
  AssignFile(F, IniFile);
  try
    Reset(F);
    l.Clear;
    Page := '[' + Page + ']';
    while not Eof(F) do begin
      ReadLn(F, s);
      if CompareText(s, Page) = 0 then begin
        ReadLn(F, s);
        p := Pos(' ', s);
        if (p > 1) then begin
          s1 := Copy(s, 1, p - 1);
          s2 := Copy(s, p + 1, 255);
        end
        else begin
          s1 := s;
          s2 := '0.5';
        end;
        try
          Height := StrToInt(s1);
        except
          Height := 65;
        end;
        try
          Scale := StrToFloat(s2);
        except
          Scale := 0.5;
        end;
        ReadLn(F, s);
        while (not Eof(F)) and (Length(s) > 0) and (s[1] <> '[') do begin
          l.Add(s);
          ReadLn(F, s);
        end;
      end;
    end;
  finally
    CloseFile(F);
  end;
end;

procedure Ver2FillFromIni(l: TStrings; IniFile, Page: string;
  var Height: integer; var Scale: single);
var
  F                 : TIniFile;
  i                 : integer;
  Count             : integer;
begin
  F := TIniFile.Create(IniFile);
  try
    l.Clear;
    Height := F.ReadInteger(Page, 'Height', 65);
    Scale := StrToFloat(F.ReadString(Page, 'Scale', '0.5'));
    Count := F.ReadInteger(Page, 'Count', 0);
    for i := 0 to Pred(Count) do begin
      l.Add(F.ReadString(Page, Format('Brick%d', [i]), ''));
    end;
  finally
    F.Free;
  end;
end;

procedure TMainForm.SetCurrentPage(n: integer);
var
  t                 : dword;
begin
  if (n < 0) then
    n := Pred(Pages.Count);

  t := GetTickCount;
  ListBox1.Items.BeginUpdate;
  InternalNoRedrawListBox := True;
  try
    if (Pages.Count > n) then begin
      CurPage := n;
      ListBox1.Items.Clear;
      if Assigned(Pages.Objects[n]) then begin
        ListBox1.Tag := integer(PgHeight[n]);
        ListBox1.Items.Assign(TStrings(Pages.Objects[n]));
      end
    end
    else begin
      CurPage := 0;
      if (Pages.Count > 0) and (Assigned(Pages.Objects[0])) then begin
        ListBox1.Tag := integer(PgHeight[0]);
        ListBox1.Items.Assign(TStrings(Pages.Objects[0]));
      end
    end;
    ComboBox1.Items.Assign(PageNames);
    ComboBox1.ItemIndex := CurPage + 1;
    if MainForm.Visible then
      ListBox1.SetFocus;
  finally
    ListBox1.Items.EndUpdate;
    InternalNoRedrawListBox := False;
    RefreshListBox;
    if miTiming.Checked then
      Caption := IntToStr(GetTickCount - t);
  end
end;

procedure TMainForm.FormDestroy(Sender: TObject);
var
  i                 : integer;
begin
  Panel2.BackGround := nil;
  Recent.Free;
  RecentCl.Free;
  WriteToIni(fIniFile);
  UpDateDataFiles;
  for i := 0 to Pred(Pages.Count) do begin
    if Assigned(Pages.Objects[i]) then
      TStringList(Pages.Objects[i]).Free;
  end;
  PageNames.Free;
  Pages.Free;
  PgHeight.Free;
  PgScale.Free;
  BackGround.Free;
  if assigned(Macro) then begin
    for i := 0 to Pred(Macro.Count) do begin
      TBlock(Macro[i]).Free;
    end;
    Macro.Free;
  end;
  Application.OnHint := nil;
  Application.ShowHint := False;
end;

procedure TMainForm.ScanStartParams;
var
  i                 : integer;
  s                 : string;
begin
  fStartModelFile := '';
  fIniFile := ExeLib + 'BlockCAD.ini';

  i := 1;
  while i <= ParamCount do begin
    s := ParamStr(i);
    if Length(s) > 0 then begin
      if s[1] in ['-', '/'] then begin
        if Length(s) > 1 then begin
          case s[2] of
            'I', 'i': begin
                if Length(s) > 2 then begin
                  fIniFile := Copy(s, 3, MAXINT);
                end
                else begin
                  Inc(i);
                  fInifile := ParamStr(i);
                end
              end
          end
        end
      end
      else begin
        if Length(fStartModelFile) = 0 then
          fStartModelFile := s
        else
          fStartModelFile := fStartModelFile + ' ' + s;
      end
    end;
    Inc(i);
  end
end;

procedure TMainForm.FormCreate(Sender: TObject);
var
  i                 : integer;
  j                 : integer;
  p                 : string;
  c                 : integer;
  h                 : integer;
  s                 : single;
  Version           : integer;
  Depth             : integer;
begin
  InternalNoRedraw := True;
  try
    Screen.Cursors[1] := LoadCursor(hInstance, 'mycursor');
    PaintBox1.ControlStyle := PaintBox1.ControlStyle + [csOpaque];
    ListBox1.ControlStyle := ListBox1.ControlStyle + [csOpaque];

    Caption := 'BlockCAD Ver ' + About.Version;
    Settings.Scale := 1.0;
    s := 40;
    SetView(70, 30);
    CalcTransform;
    //    CalcEye;
    ZLiftOff.Position := ZCutOff;
    Application.OnHint := OnHint;
    Application.ShowHint := False;
    Settings.RotXPos := RotX.Position;
    Settings.RotZPos := RotZ.Position;
    Settings.ScaleBarPos := ScaleBar.Position;
    Settings.OffsetXPos := OffsetX.Position;
    Settings.OffsetYPos := OffsetY.Position;
    Settings.StudsDown := btnStuds.Down;
    SettingsSlow := False;
    SettingsSafe := True;
    Pages := TStringList.Create;
    PageNames := TStringList.Create;
    PgHeight := TList.Create;
    PgScale := TList.Create;

    // This is the place to select a different INI-file, depending on
    // command line parameters
    ScanStartParams;

    with TIniFile.Create(fIniFile) do try
      Version := ReadInteger('Main', 'Version', 1);
      c := ReadInteger('Main', 'Pages', 0);
      PageNames.Add('<Recently used>');
      case Version of
        1: begin
            for i := 0 to Pred(c) do begin
              PageNames.Add(ReadString('Main', Format('Title%d', [i + 1]), Format('Page%d', [i + 1])));
            end;
          end;
        2: begin
            for i := 0 to Pred(c) do begin
              PageNames.Add(ReadString(Format('Page%d', [i + 1]), 'Title', ''));
            end;
          end;
      end;
      ComboBox1.Items.Assign(PageNames);
      LDrawLib := ReadString('Main', 'LDrawLIB', 'C:\LDRAW');
      LDrawProg := ReadString('Main', 'LDrawProg', 'LDRAW.EXE');
      LDrawTest := ReadString('Main', 'LDrawTest', 'MODELS\TEST.DAT');
      L2PCmd := ReadString('Main', 'L2PCmd', 'l2pgo.bat');
      L3PCmd := ReadString('Main', 'L3PCmd', 'l3pgo.bat');
      PovRayEng := ReadString('Main', 'PovRayEng', 'C:\Program\POV-Ray for Windows\bin\pvengine.exe');
      LDrawThisView1.Enabled := FileExists(LDrawLib + '\' + LDrawProg);

      Application.ShowHint := (ReadInteger('State', 'Hints', 0) = 1);
      Hints1.Checked := (ReadInteger('State', 'Hints', 0) = 1);

      i := ReadInteger('State', 'StudQual', 0);
      TBlock.SetStudQuality(i);
      FastStuds2.Checked := (FastStuds2.Tag = i);
      BetterStuds2.Checked := (BetterStuds2.Tag = i);
      BestStuds2.Checked := (BestStuds2.Tag = i);

      DetailLevel := ReadInteger('State', 'Details', 0);
      miNoDetail.Checked := (miNoDetail.Tag = DetailLevel);
      miMoreDetail.Checked := (miMoreDetail.Tag = DetailLevel);
      miMostDetail.Checked := (miMostDetail.Tag = DetailLevel);

      miShading.Checked := (ReadInteger('State', 'Shading', 0) = 1);
      miWfOnMouseRot.Checked := (ReadInteger('State', 'WfOnMouse', 1) = 1);

      Depth := ReadInteger('State', 'BitDepth', 4);
      SetBitDepth(Depth);
      case Depth of
        1: pf8bit1.Checked := True;
        2: pf16bit1.Checked := True;
        3: pf24bit1.Checked := True;
        4: pf32bit1.Checked := True;
        5: pfDevice1.Checked := True;
      end;

      LoadLGOPath := ExeLib + 'Models';
      SaveLGOPath := ExeLib + 'Models';
      LoadSASPath := ExeLib + 'Models';
      SaveSASPath := ExeLib + 'Models';
      SaveBMPPath := ExeLib + 'Pict';
      LoadBGRPath := ExeLib + 'Pict';

      LoadLGOPath := ReadString('UserPaths', 'Models', LoadLGOPath);
      SaveLGOPath := ReadString('UserPaths', 'Models', LoadLGOPath);
      LoadSASPath := ReadString('UserPaths', 'Models', LoadLGOPath);
      SaveSASPath := ReadString('UserPaths', 'Models', LoadLGOPath);
      SaveBMPPath := ReadString('UserPaths', 'Pictures', SaveBMPPath);
      LoadBGRPath := ReadString('UserPaths', 'Pictures', SaveBMPPath);

    finally
      Free;
      WritePrivateProfileString(nil, nil, nil, nil);
    end;

    Recent := TStringList.Create;
    RecentCl := TList.Create;
    RcHeight := 40;
    for i := 0 to Pred(c) do begin
      p := Format('Page%d', [i + 1]);
      Pages.AddObject(p, TStringList.Create);
      case Version of
        1: Ver1FillFromIni(TStrings(Pages.Objects[i]), fIniFile, p, h, s);
        2: Ver2FillFromIni(TStrings(Pages.Objects[i]), fIniFile, p, h, s);
      end;
      PgHeight.Add(Pointer(h));
      PgScale.Add(Pointer(s));
    end;
    if Version = 1 then begin
      WritePrivateProfileString('Main', nil, nil, PChar(fIniFile));
      for i := 0 to Pred(c) do begin
        WritePrivateProfileString(PChar(Format('Page%d', [i + 1])), nil, nil,
          PChar(fIniFile));
      end;
      WriteToIni(fIniFile);
    end;
    SetCurrentPage(0);
    ColorIndicator := edWhite.Color;
    Colors[0] := Edit1;
    Colors[1] := edWhite;
    Colors[2] := edGray;
    Colors[3] := edDarkGray;
    Colors[4] := edBlack;
    Colors[5] := Edit6;
    Colors[6] := Edit7;
    Colors[7] := edBlue;
    Colors[8] := Edit9;
    Colors[9] := Edit10;
    Colors[10] := Edit11;
    Colors[11] := Edit12;
    Colors[12] := Edit13;
    Colors[13] := Edit14;
    for i := 0 to 13 do begin
      j := 0;
      while (j < High(MatchColor)) and (Colors[i].Tag <> MatchColor[j].LDColor) do
        Inc(j);
      if (Colors[i].Tag = MatchColor[j].LDColor) then begin
        Colors[i].Color := RGB(MatchColor[j].R, MatchColor[j].G, MatchColor[j].B);
      end
    end;
    RedColor := Edit1.Color;
    GrayColor := edGray.Color;
    BlackColor := edBlack.Color;
    BlueColor := edBlue.Color;
    SelColor := clOlive;
    SelEdge := clRed;
    LineColorD := RGB(70, 70, 70);
    LineColorL := RGB(128, 128, 128);
    LineColorB := RGB(30, 178, 255);
    NextGroup := 0;

    Camera.r.Top := (PaintBox1.Height div 2) - 150;
    Camera.r.Bottom := Camera.r.Top + 300;

    Camera.r.Left := (PaintBox1.Width div 2) - 190;
    Camera.r.Right := Camera.r.Left + 400;

    Camera.h := Camera.r;
    InflateRect(Camera.h, 2, 2);
    Dec(Camera.h.Top, 12);

    Camera.State := [];

    cbResolution.ItemIndex := 0;

    cbResolutionChange(nil);

    LstBmp.Canvas.Font.Name := ListBox1.Font.Name;
    LstBmp.Canvas.Font.Size := ListBox1.Font.Size;

    btnTransparent.Glyph.Assign(btnWireBase.Glyph);
    btnPieceStuds.Glyph.Assign(btnStuds.Glyph);

    Panel2.Background := Dock971.Background;
    Dock972.Background.Assign(Dock971.Background);
    Dock973.Background.Assign(Dock971.Background);
    Dock974.Background.Assign(Dock971.Background);

    with BlockList do begin
      Oct := 0;
      Add(TBlock.CreateBlock(-8, -4, -1, 16, 8, 1, GrayColor, True, True, False, '3865'));
    end;

  finally
    InternalNoRedraw := False;
  end;
  PostMessage(Handle, REALLY_STARTED, 0, 0);
end;

procedure TMainForm.msgRedrawPicture(var Msg: TMessage);
begin
  RedrawPicture(nil);
end;

procedure TMainForm.msgReallyStarted(var msg: TMessage);
begin
  SetCurrentDir(ExeLib);

  if (Length(fStartModelFile) > 0) then begin
    MyOpenDialog.FileName := fStartModelFile;
    OpenNamedFile(fStartModelFile, omNewModel);
    Cutting.Dlg.ResetCutting;
    Cutting.Dlg.ZUp;
  end;
  ToolBar972.DockPos := 2000;
  ToolBar973.DockPos := 2000;
end;

procedure TMainForm.OnHint(Sender: TObject);
begin
  {}
end;

procedure TMainForm.PaintBox1Paint(Sender: TObject);
var
  Pts               : array[0..2] of TPoint;
  t                 : dword;
  ShadowCanvas      : TDrawObject;
const
  Painting          : Boolean = False;
begin
  if NoRedraw or Painting then Exit;

  t := GetTickCount;
  //  if Assigned(AdvOptions) then
  //    BlockList.Step := AdvOptions.spStep.AsInteger;

  //  Screen.Cursor := crHourglass;
  Painting := True;

  if miAntiAlias.Checked then begin
    try
      AntiAliasDraw(Shadow, Rect(0, 0, Shadow.Width, Shadow.Height), Shadow.Width, Shadow.Height);
      PaintBox1.Canvas.Draw(0, 0, Shadow);
    finally
      Painting := False;
      //    Screen.Cursor := crDefault;
      if miTiming.Checked then
        Caption := IntToStr(GetTickCount - t);
    end
  end
  else begin
    ShadowCanvas := TDrawObject.Create(Shadow);
    try

      Transform([Point3D(0, 0, 0), Point3D(0, 0, 3), Point3D(0, 0, PFACTORZ)], Pts, 0);
      zx := Pts[1].x - Pts[0].x;
      zy := Pts[1].y - Pts[0].y;

      zx1 := Pts[2].x - Pts[0].x;
      zy1 := Pts[2].y - Pts[0].y;

      SetStudsIncrement;

      if Octant <> BlockList.Oct then
        BlockList.SortForOctant(Octant);

      ShadowCanvas.Canvas.Brush.Color := MainForm.Color;
      if Assigned(BackGround) then
        ShadowCanvas.StretchDraw(PaintBox1.ClientRect, BackGround)
      else
        ShadowCanvas.FillRect(PaintBox1.ClientRect);

      BlockList.Draw(ShadowCanvas, False);

      //    if SettingsSlow then begin
      //      PaintBox1.Canvas.Brush.Color := MainForm.Color;
      //      PaintBox1.Canvas.FillRect(PaintBox1.ClientRect);
      //      BlockList.Draw(PaintBox1.Canvas, False);
      //    end
      //    else

      if Assigned(Shadow) then begin
        PaintBox1.Canvas.Draw(0, 0, Shadow);
      end;

    finally
      Painting := False;
      //    Screen.Cursor := crDefault;
      if miTiming.Checked then
        Caption := IntToStr(GetTickCount - t);
      ShadowCanvas.Free;
    end
  end;

  if cmsActive in Camera.State then
    DrawCamera;

end;

procedure TMainForm.AntiAliasDraw(const Bitmap: TBitmap; const CameraRect: TRect;
  const Width, Height: integer);
var
  Pts               : array[0..2] of TPoint;
  BigBitmap         : TBitMap;
  BigBitMapCanvas   : TDrawObject;
  r                 : TRect;
  SaveScale         : TMyFloat;
  SaveXB, SaveYB    : TMyFloat;
  i, j              : integer;
  j1                : integer;
  cr, cg, cb        : integer;
  p0, p1            : PRGBQuadArray;
  pd                : integer;
  q                 : TRGBQuad;
  p3                : PRGBQuadArray;
  p3d               : integer;

begin
  Screen.Cursor := crHourglass;
  BigBitmap := TBitmap.Create;
  BigBitmap.PixelFormat := pf32bit;     // The Downsample needs pf32Bit!
  BigBitmapCanvas := nil;

  SaveScale := Settings.Scale;
  SaveXB := Settings.xBase;
  SaveYB := Settings.yBase;
  try
    BigBitmap.Height := Height * 2;
    BigBitmap.Width := Width * 2;
    BigBitmapCanvas := TDrawObject.Create(BigBitmap);

    r := Rect(0, 0, BigBitmap.Width, BigBitmap.Height);
    Settings.Scale := Settings.Scale * 2.0;
    Settings.xBase := Settings.xBase * 2.0;
    Settings.yBase := Settings.yBase * 2.0;
    Transform([Point3D(0, 0, 0), Point3D(0, 0, 3), Point3D(0, 0, PFACTORZ)], Pts, 0);
    zx := Pts[1].x - Pts[0].x;
    zy := Pts[1].y - Pts[0].y;

    zx1 := Pts[2].x - Pts[0].x;
    zy1 := Pts[2].y - Pts[0].y;

    SetStudsIncrement;

    if Octant <> BlockList.Oct then
      BlockList.SortForOctant(Octant);

    BigBitmap.Canvas.Brush.Color := MainForm.Color;
    if Assigned(BackGround) then
      BigBitmap.Canvas.StretchDraw(r, BackGround)
    else
      BigBitmap.Canvas.FillRect(r);

    BlockList.Draw(BigBitmapCanvas, False);

    r := Rect(0, 0, Bitmap.Width, Bitmap.Height);

    //Downsample

    p0 := PRGBQuadArray(BigBitmap.ScanLine[CameraRect.Top * 2]);
    p1 := PRGBQuadArray(BigBitmap.ScanLine[CameraRect.Top * 2 + 1]);
    pd := (PChar(p1) - PChar(p0)) * 2;

    p3 := PRGBQuadArray(Bitmap.ScanLine[0]);
    p3d := (PChar(Bitmap.ScanLine[1]) - PChar(p3));

    for i := CameraRect.Top to Pred(CameraRect.Bottom) do begin
      j1 := 0;
      for j := CameraRect.Left to Pred(CameraRect.Right) do begin
        q := p0[j * 2];
        cr := q.rgbRed;
        cg := q.rgbGreen;
        cb := q.rgbBlue;
        q := p0[j * 2 + 1];
        cr := cr + q.rgbRed;
        cg := cg + q.rgbGreen;
        cb := cb + q.rgbBlue;
        q := p1[j * 2];
        cr := cr + q.rgbRed;
        cg := cg + q.rgbGreen;
        cb := cb + q.rgbBlue;
        q := p1[j * 2 + 1];
        cr := cr + q.rgbRed;
        cg := cg + q.rgbGreen;
        cb := cb + q.rgbBlue;
        p3[j1].rgbRed := cr div 4;
        p3[j1].rgbGreen := cg div 4;
        p3[j1].rgbBlue := cb div 4;
        Inc(j1);
      end;
      Inc(PChar(p3), p3d);
      Inc(PChar(p0), pd);
      Inc(PChar(p1), pd);
    end;

  finally
    Settings.Scale := SaveScale;
    Settings.xBase := SaveXB;
    Settings.yBase := SaveYB;
    BigBitmapCanvas.Free;
    BigBitmap.Free;
    Screen.Cursor := crDefault;
  end
end;

procedure TMainForm.LargeBmpDraw(const BigBitmap: TBitmap; const CameraRect: TRect;
  const Factor: integer);
var
  BigBitmapCanvas   : TDrawObject;
  Pts               : array[0..2] of TPoint;
  r                 : TRect;
  SaveScale         : TMyFloat;
  SaveXB, SaveYB    : TMyFloat;

begin
  BigBitmapCanvas := TDrawObject.Create(BigBitmap);
  Screen.Cursor := crHourglass;
  SaveScale := Settings.Scale;
  SaveXB := Settings.xBase;
  SaveYB := Settings.yBase;
  try
    r := Rect(0, 0, BigBitmap.Width, BigBitmap.Height);

    Settings.Scale := Settings.Scale * Factor;
    Settings.xBase := (Settings.xBase - CameraRect.Left) * Factor;
    Settings.yBase := (Settings.yBase - CameraRect.Top) * Factor;

    Transform([Point3D(0, 0, 0), Point3D(0, 0, 3), Point3D(0, 0, PFACTORZ)], Pts, 0);
    zx := Pts[1].x - Pts[0].x;
    zy := Pts[1].y - Pts[0].y;

    zx1 := Pts[2].x - Pts[0].x;
    zy1 := Pts[2].y - Pts[0].y;

    SetStudsIncrement;

    if Octant <> BlockList.Oct then
      BlockList.SortForOctant(Octant);

    BigBitmap.Canvas.Brush.Color := PaintBox1.Color;
    if Assigned(BackGround) then
      BigBitmap.Canvas.StretchDraw(r, BackGround)
    else
      BigBitmap.Canvas.FillRect(r);

    BlockList.Draw(BigBitmapCanvas, False);

  finally
    Settings.Scale := SaveScale;
    Settings.xBase := SaveXB;
    Settings.yBase := SaveYB;
    Screen.Cursor := crDefault;
  end
end;

procedure TMainForm.RotXChange(Sender: TObject);
begin
  rx := Round(RotX.Position) * DEG2RAD;
  ry := Round(RotY.Position) * DEG2RAD;
  rz := Round(RotZ.Position) * DEG2RAD;
  CalcTransform;
  //  CalcEye;
  RedrawPicture(Sender);
  //  Caption := IntToStr(Octant);
end;

function StringFromBlock(b: TBlock): string;
var
  ql, qb, qh        : integer;
begin
  if Assigned(b) then begin
    if Odd(b.Dir) then begin
      ql := b.pb div PFACTORXY;
      qb := b.pl div PFACTORXY;
    end
    else begin
      ql := b.pl div PFACTORXY;
      qb := b.pb div PFACTORXY;
    end;
    qh := b.ph div PFACTORZ * 3;
    if b.t = 'G' then
      Result := b.t + ' ' + TGeneralBlock(b).FilNam + ',' + TGeneralBlock(b).PrtNam
    else
      Result := b.t + ' ' + IntToStr(ql) + 'x' + IntToStr(qb) + 'x' + IntToStr(qh);

    if Length(b.PartId) > 0 then
      Result := Result + '|' + b.PartId;
  end
  else
    Result := '';
end;

function TMainForm.FirstInGroup(const g: integer): integer;
begin
  for Result := 0 to Pred(BlockList.Count) do begin
    if (TBlock(BlockList[Result]).Group = g) then
      Exit;
  end;
  Result := -1;
end;

function TMainForm.NextInGroup(const g, b: integer): integer;
begin
  for Result := b + 1 to Pred(BlockList.Count) do begin
    if (TBlock(BlockList[Result]).Group = g) then
      Exit;
  end;
  Result := -1;
end;

procedure TMainForm.PlacePiece(var lg: integer);
var
  i                 : integer;
begin
  if Cutting.Dlg.BlockVisible(piece) then begin
    LastX := Piece.px;
    LastY := Piece.py;
    LastZ := Piece.pz;
    if LoadingMacro then begin
      BlockList.Concat(Macro, Piece.px, Piece.py, Piece.pz);
      for i := 0 to Pred(Macro.Count) do begin
        BlockList.UndoSave('+', TBlock(Macro[i]));
        with TBlock(Macro[i]) do begin
          if (Group > 0) then
            lg := Min(lg, Group);
        end
      end;
      Inc(NextGroup);
      for i := 0 to Pred(Macro.Count) do begin
        with TBlock(Macro[i]) do begin
          Group := Group - lg + NextGroup
        end
      end
    end
    else begin
      BlockList.UndoSave('+', Piece);
      BlockList.Add(Piece);
    end;

    Modified := True;
    BlockList.SortForOctant(Octant);
    RedrawPicture(nil);
    if JustOne then begin
      Piece := nil;
      JustOne := False;
      if Assigned(Macro) then begin
        for i := 0 to Pred(Macro.Count) do
          TBlock(Macro[i]).Free;
        Macro.Free;
        Macro := nil;
        LoadingMacro := False;
      end;
      PaintBox1.Cursor := crDefault;
    end
    else begin
      if not Assigned(Macro) then
        Piece := TBlock.CreateCopy(Piece);
      RedrawCursorPiece;
    end
  end
end;

const
  swf               : Boolean = False;

procedure TMainForm.PaintBox1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  i                 : integer;
  pt                : TPoint;
  dp                : TPoint3D;
  tx, ty            : integer;
  m0x, m1x, m0y, m1y, m0z, m1z: integer;
  Sel               : boolean;
  b                 : TBlock;
  lg                : integer;

  procedure TurnPiece;
  var
    i               : integer;
  begin
    ClearCursorPiece;
    if LoadingMacro then begin
      for i := 0 to Pred(Macro.Count) do begin
        with TBlock(Macro[i]) do begin
          tx := px;
          ty := py;
          px := ty;
          py := -tx - pl;
          Turn;
        end
      end;
      Piece.Turn;
    end
    else begin
      Piece.Turn;
      Modified := True;
    end;
    RedrawCursorPiece;
  end;

begin                                   { PaintBox1MouseDown }
  lg := 999999;
  mx := x;
  my := y;
  if cmsActive in Camera.State then begin
    Camera.State := [cmsActive];
    if ssLeft in Shift then begin

      if PtInRect(Camera.r, Point(x, y)) then begin
        Camera.State := [cmsActive, cmsMove];

        if (Abs(y - Camera.r.Top) <= 3) then begin
          Include(Camera.State, cmsSizeN);
          Exclude(Camera.State, cmsMove);
        end
        else if (Abs(y - Camera.r.Bottom) <= 3) then begin
          Include(Camera.State, cmsSizeS);
          Exclude(Camera.State, cmsMove);
        end;

        if (Abs(x - Camera.r.Left) <= 3) then begin
          Include(Camera.State, cmsSizeW);
          Exclude(Camera.State, cmsMove);
        end
        else if (Abs(x - Camera.r.Right) <= 3) then begin
          Include(Camera.State, cmsSizeE);
          Exclude(Camera.State, cmsMove);
        end
      end
      else if PtInRect(Camera.rx, Point(x, y)) then begin
        btnSavePic.Down := False;
        Camera.State := [];
        DrawCamera;
      end
      else if PtInRect(Camera.rmax, Point(x, y)) then begin
        //        DrawCamera;
        Camera.r.Top := 0 + 14;
        Camera.r.Bottom := PaintBox1.ClientHeight - 2;
        Camera.r.Left := 0 + 2;
        Camera.r.Right := PaintBox1.ClientWidth - 2;
        DrawCamera;
      end
      else if PtInRect(Camera.rmin, Point(x, y)) then begin
        //        DrawCamera;
        if ssCtrl in Shift then begin
          Camera.r.Bottom := Camera.r.Top + 192;
          Camera.r.Right := Camera.r.Left + 150;
        end
        else if ssShift in Shift then begin
          Camera.r.Bottom := Camera.r.Top + 240;
          Camera.r.Right := Camera.r.Left + 320;
        end
        else if ssAlt in Shift then begin
          Camera.r.Bottom := Camera.r.Top + 480;
          Camera.r.Right := Camera.r.Left + 640;
        end
        else begin
          Camera.r.Bottom := Camera.r.Top + 116;
          Camera.r.Right := Camera.r.Left + 116;
        end;
        DrawCamera;
      end
      else if PtInRect(Camera.ro, Point(x, y)) then begin
        SavePicture(0);
      end
      else if PtInRect(Camera.ra, Point(x, y)) then begin
        SavePicture(1);
      end
      else if PtInRect(Camera.r2, Point(x, y)) then begin
        SavePicture(2);
      end
      else if PtInRect(Camera.r4, Point(x, y)) then begin
        SavePicture(4);
      end
      else if PtInRect(Camera.r8, Point(x, y)) then begin
        SavePicture(8);
      end
      else if PtInRect(Camera.tx, Point(x, y)) then begin
        SizeCamera.Top := Top + Panel3.Top + Camera.r.Top - 1 + 12;
        SizeCamera.Left := Left + Panel3.Left + Camera.r.Right + 4;
        if (SizeCamera.Left + SizeCamera.Width) > (Left + Panel3.Left + Panel3.Width) then
          SizeCamera.Left := Left + Panel3.Left + Panel3.Width - SizeCamera.Width;
        SizeCamera.W := Camera.r.Right - Camera.r.Left;
        SizeCamera.H := Camera.r.Bottom - Camera.r.Top;
        if SizeCamera.ShowModal = mrOK then begin
          tx := SizeCamera.W - (Camera.r.Right - Camera.r.Left);
          ty := SizeCamera.H - (Camera.r.Bottom - Camera.r.Top);
          Camera.r.Left := Camera.r.Left - tx div 2;
          Camera.r.Right := Camera.r.Left + SizeCamera.W;
          Camera.r.Top := Camera.r.Top - ty div 2;
          Camera.r.Bottom := Camera.r.Top + SizeCamera.H;
          DrawCamera;
        end;
      end
    end;
    exit;
  end;
  if Assigned(Piece) then begin
    if ssLeft in Shift then begin
      SetCursorPiece(x, y);
      PlacePiece(lg);
    end
    else if ssRight in Shift then begin
      TurnPiece;
    end
  end
  else begin
    if not (ssShift in Shift) then begin
      i := BlockList.FindBlockAtScreenPos(x, y);
      if (i >= 0) then begin            { Found a block at the cursor position }
        with TBlock(BlockList.Items[i]) do begin
          if (ssRight in Shift) then begin
            if (ssAlt in Shift) then begin
              BlockList.UndoSave('[', BlockList[i]);
              st := not st;
              BlockList.UndoSave(']', BlockList[i]);
            end
            else if (ssCtrl in Shift) then begin
              { should really turn _all_ pieces in group. OK }
              { should maybe turn group as a whole (as when placing a group) }
              if Group > 0 then begin
                i := FirstInGroup(Group);
                while (i >= 0) do begin
                  BlockList.UndoSave('[', BlockList[i]);
(* Turn as a whole, not ready ...
                  with TBlock(BlockList[i]) do begin
                    tx := px;
                    ty := py;
                    px := ty;
                    py := -tx - pl;
                    Turn;
                  end;
*)
                  TBlock(BlockList[i]).Turn;
                  BlockList.UndoSave(']', BlockList[i]);
                  i := NextInGroup(Group, i);
                end;
(* Turn as a whole, not ready ...
                BlockList.SortForOctant(Octant);
*)
              end
              else begin
                BlockList.UndoSave('[', BlockList[i]);
                Turn;
                BlockList.UndoSave(']', BlockList[i]);
              end
            end
            else begin
              { should really color _all_ pieces in group? NO }
              BlockList.UndoSave('[', BlockList[i]);
              cl := ColorIndicator;
              Transp := btnTransparent.Down;
              BlockList.UndoSave(']', BlockList[i]);
            end;
            Modified := True;
            RedrawPicture(Sender);
          end
          else { left click }  if bp = False then begin
            Piece := TBlock(BlockList.Items[i]);
            if (ssCtrl in Shift) then begin { select/deselect piece even if in group}
              Piece.Selected := not Piece.Selected;
              AdvOptions.SelectionChanged;
            end
            else begin
              if (Piece.Group > 0) then begin { select/deselect the group }
                i := FirstInGroup(Piece.Group);
                Sel := Piece.Selected;
                while (i >= 0) do begin
                  TBlock(BlockList[i]).Selected := not Sel;
                  i := NextInGroup(Piece.Group, i);
                end;
                AdvOptions.SelectionChanged;
              end
              else begin                { select/deselect piece }
                Piece.Selected := not Piece.Selected;
                AdvOptions.SelectionChanged;
              end
            end;
            Piece := nil;
            RedrawPicture(Sender);
          end;
        end;
      end
    end
    else begin                          {ssShift in Shift}
      if (Button = mbLeft) and (not LoadingMacro) then begin
        i := BlockList.FindBlockAtScreenPos(x, y);
        if (i >= 0) then begin          { Found a block at the cursor position }
          if (TBlock(BlockList[i]).Selected) or (ssAlt in Shift) then begin
            if not Assigned(Macro) then
              Macro := TBlockList.Create;
            m1x := 9999;
            m1y := 9999;
            m1z := 9999;
            m0x := -9999;
            m0y := -9999;
            m0z := -9999;

            if (ssAlt in Shift) then
              Inc(NextGroup);

            for i := 0 to Pred(BlockList.Count) do begin
              if TBlock(BlockList[i]).Selected then begin
                with TBlock(BlockList[i]) do begin
                  Selected := False;
                  m0x := Max(m0x, px + pl);
                  m0y := Max(m0y, py + pb);
                  m0z := Max(m0z, pz + ph);
                  m1x := Min(m1x, px);
                  m1y := Min(m1y, py);
                  m1z := Min(m1z, pz);
                end;
                if (ssAlt in Shift) then begin { Grab a copy of the selected pieces }
                  b := TBlock.CreateCopy(BlockList[i]);
                  b.Group := NextGroup;
                  Macro.Add(b);
                end
                else begin              { Grab the selected pieces }
                  Macro.Add(BlockList[i]);
                  BlockList.UndoSave('-', BlockList[i]);
                  BlockList[i] := nil;
                end
              end;
              AdvOptions.SelectionChanged;
            end;
            for i := Pred(BlockList.Count) downto 0 do begin
              if (BlockList[i] = nil) then
                BlockList.Delete(i);
            end;
            if Macro.Count > 0 then begin
              LoadingMacro := True;
              SetUpNewPiece(CreateBlockFromString(Format(' %dx%dx%d',
                [(m0x - m1x) div PFACTORXY,
                (m0y - m1y) div PFACTORXY,
                  (m0z - m1z) * 3 div PFACTORZ])));

              Pt := ScreenCoord(Point3D(m1x, m1y, m1z), 0);
              Pt := PaintBox1.ClientToScreen(Pt);
              SetCursorPos(Pt.x, Pt.y);

              JustOne := not (ssAlt in Shift);
              RedrawPicture(nil);
            end
            else begin
              Macro.Free;
              Macro := nil;
            end
          end
          else begin                    { Shift+Left, not selected }
            Piece := TBlock(BlockList[i]);
            if not Piece.bp then begin
              if Piece.Group > 0 then begin
                if not Assigned(Macro) then
                  Macro := TBlockList.Create;
                m1x := 9999;
                m1y := 9999;
                m1z := 9999;
                m0x := -9999;
                m0y := -9999;
                m0z := -9999;

                if (ssAlt in Shift) then
                  Inc(NextGroup);

                for i := 0 to Pred(BlockList.Count) do begin
                  if TBlock(BlockList[i]).Group = Piece.Group then begin
                    with TBlock(BlockList[i]) do begin
                      m0x := Max(m0x, px + pl);
                      m0y := Max(m0y, py + pb);
                      m0z := Max(m0z, pz + ph);
                      m1x := Min(m1x, px);
                      m1y := Min(m1y, py);
                      m1z := Min(m1z, pz);
                    end;
                    if (ssAlt in Shift) then begin { Grab a copy of the selected pieces }
                      b := TBlock.CreateCopy(BlockList[i]);
                      b.Group := NextGroup;
                      Macro.Add(b);
                    end
                    else begin          { Grab the selected pieces }
                      Macro.Add(BlockList[i]);
                      BlockList.UndoSave('-', BlockList[i]);
                      BlockList[i] := nil;
                    end
                  end;
                  AdvOptions.SelectionChanged;
                end;
                for i := Pred(BlockList.Count) downto 0 do begin
                  if (BlockList[i] = nil) then
                    BlockList.Delete(i);
                end;
                if Macro.Count > 0 then begin
                  Piece := nil;
                  LoadingMacro := True;
                  SetUpNewPiece(CreateBlockFromString(Format(' %dx%dx%d',
                    [(m0x - m1x) div PFACTORXY,
                    (m0y - m1y) div PFACTORXY,
                      (m0z - m1z) * 3 div PFACTORZ])));

                  Pt := ScreenCoord(Point3D(m1x, m1y, m1z), 0);
                end
                else begin
                  Macro.Free;
                  Macro := nil;
                  Piece := nil;
                end
              end
              else begin
                BlockList.UndoSave('-', BlockList[i]);
                BlockList.Delete(i);
                Dp := Piece.ZeroPoint;
                Pt := ScreenCoord(Point3D(Dp.x, Dp.y, Dp.z), 0);
              end;
              Modified := True;
              JustOne := True;
              Pt := PaintBox1.ClientToScreen(Pt);
              SetCursorPos(Pt.x, Pt.y);
              RedrawPicture(nil);
            end
            else
              Piece := nil
          end
        end
      end
      else if (Button = mbRight) and (not LoadingMacro) then begin
        if miWfOnMouseRot.Checked then begin
          swf := btnWireFrame.Down;
          if not swf then begin
            btnWireFrame.down := True;
            btnWireFrameClick(nil);
          end
        end
      end
    end
  end
end;

procedure TMainForm.RedrawCursorPiece;
var
  Pts               : array[0..3] of TPoint;
  i                 : integer;
  t                 : TBlockList;
  PBCanvas          : TDrawObject;
begin
  if Assigned(Piece) then begin
    PBCanvas := TDrawObject.Create(PaintBox1.Canvas);
    try
      Transform([Point3D(0, 0, 0), Point3D(0, 0, 3), Point3D(0, 0, PFACTORZ)], Pts, 0);
      zx := Pts[1].x - Pts[0].x;
      zy := Pts[1].y - Pts[0].y;

      zx1 := Pts[2].x - Pts[0].x;
      zy1 := Pts[2].y - Pts[0].y;

      SetStudsIncrement;
      //      if cmsActive in Camera.State then
      //        DrawCamera;
      if LoadingMacro then begin
        T := TBlockList.Create;
        try
          T.Concat(Macro, Piece.px, Piece.py, Piece.pz);
          T.Step := Macro.Step;
          T.Draw(PBCanvas, True);
        finally
          for i := 0 to Pred(T.Count) do
            TBlock(T.Items[i]).Free;
          T.Free;
        end
      end
      else begin
        Piece.Draw(PBCanvas);
      end;
      if cmsActive in Camera.State then
        DrawCamera;
    finally
      PBCanvas.Free;
    end
  end;
end;

procedure TMainForm.ClearCursorPiece;
begin
  PaintBox1.Canvas.Draw(0, 0, Shadow);
  if cmsActive in Camera.State then
    DrawCamera;
end;

function TMainForm.ZLevel(const Pxx, Pyy, Pll, Pbb: integer): integer;
var
  i                 : integer;
begin
  Result := Max(0, Cutting.Dlg.ZLevel);
  with BlockList do
    for i := 0 to Pred(Count) do begin
      with TBlock(Items[i]) do begin
        if Cutting.Dlg.BlockVisible(Items[i]) then
          Result := Max(Result, ZLevel(Pxx, Pyy, Pll, Pbb));
      end;
    end;
end;

procedure TMainForm.ScreenXYTo3D(const sx, sy: integer; var xx, yy, zz: integer; const ll, bb: integer);
var
  x0, y0, x1, y1, sc, xb, yb, dn: TMyFloat;
  i                 : integer;
  bl                : TBlock;
  mx, my, mz        : integer;
begin
  x0 := sx;
  y0 := sy;
  xb := Settings.xBase;
  yb := Settings.yBase;
  sc := Settings.Scale;
  if Abs(tr00[0]) > 0.00001 then begin
    dn := sc * (tr01[0] * tr10[0] - tr00[0] * tr11[0]);
    if Abs(dn) < 0.00001 then
      y1 := 0
    else
      y1 := (tr10[0] * (x0 - xb) + tr00[0] * (y0 - yb)) / dn;
    x1 := ((x0 - xb) / sc - tr01[0] * y1) / tr00[0];
  end
  else begin
    if Abs(tr10[0]) < 0.00001 then
      x1 := 0
    else
      x1 := (yb - y0) / sc / tr10[0];
    if Abs(tr01[0]) < 0.00001 then
      y1 := 0
    else
      y1 := (x0 - xb) / sc / tr01[0];
  end;
  xx := Floor(x1);
  yy := Floor(y1);
  case Resolution of
    rNormal: begin
        xx := (xx div PFACTORXY) * PFACTORXY;
        yy := (yy div PFACTORXY) * PFACTORXY;
      end;
    rHalf: begin
        xx := (xx * 2 div PFACTORXY) * (PFACTORXY div 2);
        yy := (yy * 2 div PFACTORXY) * (PFACTORXY div 2);
      end;
  end;
  if LoadingMacro and (Macro.Count > 0) then begin
    zz := -99999;
    mx := 99999;
    my := 99999;
    mz := 99999;
    for i := 0 to Pred(Macro.Count) do begin
      with TBlock(Macro[i]) do begin
        if px < mx then mx := px;
        if py < my then my := py;
        if pz < mz then mz := pz;
      end
    end;
    for i := 0 to Pred(Macro.Count) do begin
      bl := TBlock(Macro[i]);
      zz := Max(zz, ZLevel(bl.px - mx + xx, bl.py - my + yy, bl.pl, bl.pb) - (bl.pz - mz));
    end;
  end
  else begin
    zz := ZLevel(xx, yy, ll, bb);
  end
end;

procedure TMainForm.SetCursorPiece(const x, y: integer);
var
  Dummy             : integer;
  x0, y0, sc, xxb, yyb: TMyFloat;
begin
  if Assigned(Piece) then begin
    with Piece do begin
      if (Abs(rx - pi / 2.0) < 0.0) then begin
        x0 := x;
        y0 := y;
        xxb := Settings.xBase;
        yyb := Settings.yBase;
        sc := Settings.Scale;
        if ((rz >= 7 * pi / 4) or (rz < pi / 4)) then begin
          px := Round((x0 - xxb) / sc); {}
          pz := Round((yyb - y0) / sc); {}
        end
        else if ((rz >= pi / 4) and (rz < 3 * pi / 4)) then begin
          py := Round((x0 - xxb) / sc); {}
          pz := Round((yyb - y0) / sc); {}
        end
        else if ((rz >= 3 * pi / 4) and (rz < 5 * pi / 4)) then begin
          px := Round((xxb - x0) / sc); {}
          pz := Round((yyb - y0) / sc); {}
        end
        else if ((rz >= 5 * pi / 4) and (rz < 7 * pi / 4)) then begin
          py := Round((xxb - x0) / sc); {}
          pz := Round((yyb - y0) / sc); {}
        end;
        if SettingsSafe then begin
          case Resolution of
            rNormal: begin
                px := (px div PFACTORXY) * PFACTORXY;
                py := (py div PFACTORXY) * PFACTORXY;
              end;
            rHalf: begin
                px := (px * 2 div PFACTORXY) * PFACTORXY div 2;
                py := (py * 2 div PFACTORXY) * PFACTORXY div 2;
              end;
          end;
          pz := ZLevel(px, py, pl, pb);
        end;
      end
      else begin
        //        DebugPrint(Format('-- x= %d, y= %d', [piece.px, piece.py]));
        ScreenXYTo3D(x, y, px, py, Dummy, pl, pb);
        //        DebugPrint(Format('++ x= %d, y= %d', [piece.px, piece.py]));
        if SettingsSafe then begin
          pz := Dummy;
        end
        else begin
          case Resolution of
            rNormal: begin
                pz := (pz * 3 div PFACTORZ) * PFACTORZ div 3;
              end;
            rHalf: begin
                pz := (pz * 2 * 3 div PFACTORZ) * PFACTORZ div 3 div 2;
              end;
          end;
        end;
      end;
    end;
  end;
end;

procedure TMainForm.DrawCamera;
var
  r                 : TRect;
  bm                : TBitMap;
begin
  bm := TBitMap.Create;
  try
    bm.Assign(Shadow);
    if cmsActive in Camera.State then
      with bm.Canvas do begin
        Brush.Style := bsClear;
        Pen.Color := clBlack;
        r := Camera.r;
        Rectangle(r.Left, r.Top, r.Right, r.Bottom);
        Dec(r.Top, 13);
        Rectangle(r.Left, r.Top, r.Right, r.Bottom);

        Font.Assign(Self.Font);

        TextOut(r.Right + 4, r.Top, Format('%d x %d', [r.Right - r.Left, r.Bottom - r.Top - 13]));
        Pen.Color := clSilver;

        Font.Assign(PaintBox1.Font);
        Font.Color := clGreen;

        { X - Close window, extreme right }
        TextOut(r.Right - 12, r.Top + 2, #114);

        { [] - Maximize, second right }
        TextOut(r.Right - 26, r.Top + 2, #49);

        { _ - Minimize, third right }
        TextOut(r.Right - 42, r.Top + 2, #48);

        { O - Take snapshot, extreme left }
        TextOut(r.Left + 4, r.Top + 2, #110);

        Font.Assign(Self.Font);
        Font.Color := clWhite;
        Brush.Style := bsSolid;
        Brush.Color := clGreen;

        { A - Take Anit-aliased snapshot, second to left }
        if (r.Left + 4 + 20 + 8) < Camera.rmin.Left then
          TextOut(r.Left + 4 + 20, r.Top, ' A ');

        { 2 - Take snapshot, size * 2}
        if (r.Left + 4 + 40 + 8) < Camera.rmin.Left then
          TextOut(r.Left + 4 + 40, r.Top, ' 2 ');

        { 4 - Take snapshot, size * 4}
        if (r.Left + 4 + 60 + 8) < Camera.rmin.Left then
          TextOut(r.Left + 4 + 60, r.Top, ' 4 ');

        { 8 - Take snapshot, size * 8}
        if (r.Left + 4 + 80 + 8) < Camera.rmin.Left then
          TextOut(r.Left + 4 + 80, r.Top, ' 8 ');

        Camera.rx := Rect(r.Right - 12, r.Top, r.Right - 4, r.Top + 12);
        Camera.rmax := Rect(r.Right - 26, r.Top, r.Right - 18, r.Top + 12);
        Camera.rmin := Rect(r.Right - 42, r.Top, r.Right - 34, r.Top + 12);
        Camera.ro := Rect(r.Left + 4, r.Top, r.Left + 4 + 7 + 1, r.Top + 12);
        Camera.ra := Rect(r.Left + 4 + 20, r.Top, r.Left + 4 + 20 + 7 + 1, r.Top + 12);
        Camera.r2 := Rect(r.Left + 4 + 40, r.Top, r.Left + 4 + 40 + 7 + 1, r.Top + 12);
        Camera.r4 := Rect(r.Left + 4 + 60, r.Top, r.Left + 4 + 60 + 7 + 1, r.Top + 12);
        Camera.r8 := Rect(r.Left + 4 + 80, r.Top, r.Left + 4 + 80 + 7 + 1, r.Top + 12);
        Camera.tx := Rect(r.Right + 4, r.Top, r.Right + 4 + 50, r.Top + 12);
      end;
    PaintBox1.Canvas.Draw(0, 0, bm);
  finally
    bm.Free;
  end
end;

procedure TMainForm.PaintBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var
  xp, yp, zp        : integer;

begin
  //  Screen.Cursor := crDefault;
  if cmsActive in Camera.State then begin
    //    DrawCamera;
    if ssLeft in Shift then begin
      if cmsSizeN in Camera.State then begin
        Camera.r.Top := Camera.r.Top + (y - my);
        if Camera.r.Top + 64 > Camera.r.Bottom then
          Camera.r.Top := Camera.r.Bottom - 64;
        my := y;
      end;
      if cmsSizeS in Camera.State then begin
        Camera.r.Bottom := Camera.r.Bottom + (y - my);
        if Camera.r.Top + 64 > Camera.r.Bottom then
          Camera.r.Bottom := Camera.r.Top + 64;
        my := y;
      end;
      if cmsSizeW in Camera.State then begin
        Camera.r.Left := Camera.r.Left + (x - mx);
        if Camera.r.Left + 64 > Camera.r.Right then
          Camera.r.Left := Camera.r.Right - 64;
        mx := x;
      end;
      if cmsSizeE in Camera.State then begin
        Camera.r.Right := Camera.r.Right + (x - mx);
        if Camera.r.Left + 64 > Camera.r.Right then
          Camera.r.Right := Camera.r.Left + 64;
        mx := x;
      end;
      if cmsMove in Camera.State then begin
        Camera.r.Top := Camera.r.Top + (y - my);
        Camera.r.Bottom := Camera.r.Bottom + (y - my);
        Camera.r.Left := Camera.r.Left + (x - mx);
        Camera.r.Right := Camera.r.Right + (x - mx);
        mx := x;
        my := y;
      end;
    end
    else begin
      if PtInRect(Camera.r, Point(x, y)) then begin
        Screen.Cursor := 1;
        if (Abs(y - Camera.r.Top) <= 3) then begin
          Screen.Cursor := crSizeNS;
          if (Abs(x - Camera.r.Left) <= 3) then begin
            Screen.Cursor := crSizeNWSE;
          end
          else if (Abs(x - Camera.r.Right) <= 3) then begin
            Screen.Cursor := crSizeNESW;
          end
        end
        else if (Abs(y - Camera.r.Bottom) <= 3) then begin
          Screen.Cursor := crSizeNS;
          if (Abs(x - Camera.r.Left) <= 3) then begin
            Screen.Cursor := crSizeNESW;
          end
          else if (Abs(x - Camera.r.Right) <= 3) then begin
            Screen.Cursor := crSizeNWSE;
          end
        end
        else if (Abs(x - Camera.r.Left) <= 3) then begin
          Screen.Cursor := crSizeWE;
        end
        else if (Abs(x - Camera.r.Right) <= 3) then begin
          Screen.Cursor := crSizeWE;
        end
      end
      else begin
        if PtInRect(Camera.rx, Point(x, y))
          or PtInRect(Camera.rmax, Point(x, y))
          or PtInRect(Camera.rmin, Point(x, y))
          or PtInRect(Camera.ro, Point(x, y))
          or PtInRect(Camera.ra, Point(x, y))
          or PtInRect(Camera.r2, Point(x, y))
          or PtInRect(Camera.r4, Point(x, y))
          or PtInRect(Camera.r8, Point(x, y)) then
          Screen.Cursor := crHandPoint
        else
          Screen.Cursor := crDefault;
      end;
    end;
    DrawCamera;
    exit;
  end;

  if Assigned(Piece) then begin
    PaintBox1.Cursor := crNone;         //crDrag;
    xp := Piece.px;
    yp := Piece.py;
    zp := Piece.pz;
    SetCursorPiece(x, y);
    if (xp <> Piece.px) or (yp <> Piece.py) or (zp <> Piece.pz) then begin
      ClearCursorPiece;
      RedrawCursorPiece;
    end;
    AdvOptions.ShowCoord(Piece);
  end
  else begin
    if ssShift in Shift then begin
      PaintBox1.Cursor := crDefault;
      ClearCursorPiece;
      if ssRight in Shift then begin
        if (Abs(x - mx) > 1) or
          (Abs(y - my) > 1) then begin
          zp := RotZ.Position + (x - mx);
          if zp < RotZ.Min then
            zp := RotZ.Max
          else if zp > RotZ.Max then
            zp := RotZ.Min;

          xp := RotX.Position - (y - my);
          if xp < RotX.Min then
            xp := RotX.Min
          else if xp > RotX.Max then
            xp := RotX.Max;

          SetView(xp, zp);

          mx := x;
          my := y;
        end
      end
      else if False {ssLeft in Shift} then begin
        { Translation can only be done with the scrollbars for the moment  }
        { The code is left here if I want to use it sometime in the future }
        if (Abs(x - mx) > 4) or
          (Abs(y - my) > 4) then begin
          xp := OffsetX.Position - (x - mx);
          if xp < OffsetX.Min then
            xp := OffsetX.Min
          else if xp > OffsetX.Max then
            xp := OffsetX.Max;

          yp := OffsetY.Position - (y - my);
          if yp < OffsetY.Min then
            yp := OffsetY.Min
          else if yp > OffsetY.Max then
            yp := OffsetY.Max;

          OffsetX.Position := xp;
          OffsetY.Position := yp;
          mx := x;
          my := y;
          SetBase;
        end;
      end;
    end
    else begin
    end
  end;
end;

procedure TMainForm.DrawScene;
begin
  InternalNoRedraw := True;
  try
    NoRedraw := True;
    RotX.Position := Settings.RotXPos;
    RotZ.Position := Settings.RotZPos;
    ScaleBar.Position := Settings.ScaleBarPos;
    (*
        StudsDown: Boolean;
    *)
    RotXChange(nil);
  finally
    InternalNoRedraw := False;
    RedrawPicture(nil);
  end;
end;

procedure TMainForm.RedrawPicture(Sender: TObject);
begin
  if InternalNoRedraw = False then begin
    NoRedraw := False;
    PaintBox1.Repaint;                  //Invalidate;
  end;
end;

procedure TMainForm.btnRefreshClick(Sender: TObject);
begin
  with BlockList do begin
    Oct := 99;
    Screen.Cursor := crHourGlass;
    try
      SortForOctant(Octant);
      RedrawPicture(Sender);
    finally
      Screen.Cursor := crDefault;
    end
  end
end;

procedure TMainForm.ScaleBarChange(Sender: TObject);
begin
  Settings.Scale := 10.0 / Round(ScaleBar.Position);
  RedrawPicture(Sender);
end;

procedure TMainForm.OffsetXChange(Sender: TObject);
begin
  SetBase;
  RedrawPicture(Sender);
end;

procedure TMainForm.FormResize(Sender: TObject);
begin
  Shadow.Height := PaintBox1.ClientHeight;
  Shadow.Width := PaintBox1.ClientWidth;

  OffsetX.Width := Panel8.Width - OffsetY.Width;
  OffsetY.Height := Panel9.Height;

  btnHome.Height := OffsetX.Height - 1;
  btnHome.Width := OffsetY.Width - 1;
  btnHome.Left := Panel8.Width - btnHome.Width;
  SetBase;
  ListBox1.SetBounds(ListBox1.Left, ListBox1.Top,
    Panel2.ClientWidth - 2 * ListBox1.Left,
    Panel2.ClientHeight - ListBox1.Top - 4);
end;

procedure TMainForm.btnHomeClick(Sender: TObject);
begin
  CenterInDisplay;
end;

procedure TMainForm.CenterInDisplay;
var
  i                 : integer;
  m0x, m0y, m0z     : integer;
  m1x, m1y, m1z     : integer;
  ox, oy, oz        : integer;
  Result            : TPoint;
begin
  m0x := -99999;
  m0y := -99999;
  m0z := -99999;
  m1x := 99999;
  m1y := 99999;
  m1z := 99999;
  for i := 0 to Pred(BlockList.Count) do begin
    with TBlock(BlockList[i]) do begin
      m0x := Max(m0x, px + pl);
      m0y := Max(m0y, py + pb);
      m0z := Max(m0z, pz + ph);
      m1x := Min(m1x, px);
      m1y := Min(m1y, py);
      m1z := Min(m1z, pz);
    end
  end;
  ox := (m0x + m1x) div 2;
  oy := (m0y + m1y) div 2;
  oz := (m0z + m1z) div 2;
  Result := ScreenCoord(Point3D(ox, oy, oz), 0);
  InternalNoRedraw := True;
  try
    OffsetX.Position := OffsetX.Position + (Result.x - PaintBox1.ClientWidth div 2);
    OffsetY.Position := OffsetY.Position + (Result.y - PaintBox1.ClientHeight div 2);
  finally
    InternalNoRedraw := False;
    RedrawPicture(nil);
  end
end;

procedure TMainForm.SetView(x, z: integer);
begin
  InternalNoRedraw := True;
  try
    NoRedraw := True;
    RotX.Position := x;
    RotZ.Position := z;
  finally
    InternalNoRedraw := False;
    NoRedraw := False;
    PaintBox1.Repaint;                  //Invalidate;
  end;
end;

procedure TMainForm.RadioGroup1Click(Sender: TObject);
begin
  case TComponent(Sender).Tag of
    0: SetView(0, RotZ.Position);
    1: SetView(RotX.Position, 0);
    2: SetView(RotX.Position, 270);
    3: SetView(RotX.Position, 90);
    4: SetView(RotX.Position, 180);
    5: SetView(70, 30);
    6: SetView(70, 210);
    7: SetView(70, 150);
    8: SetView(70, 330);
    9: SetView(90, RotZ.Position);
  end;
end;

procedure TMainForm.btnRotUpClick(Sender: TObject);
begin
  with RotX do
    Position := Position + SmallChange;
end;

procedure TMainForm.btnRotDownClick(Sender: TObject);
begin
  with RotX do
    Position := Position - SmallChange;
end;

procedure TMainForm.btnRotLeftClick(Sender: TObject);
begin
  with RotZ do
    if Position = Min then
      Position := Max - SmallChange
    else
      Position := Position - SmallChange;
end;

procedure TMainForm.btnRotRightClick(Sender: TObject);
begin
  with RotZ do
    if Position >= Max then
      Position := Min + SmallChange
    else
      Position := Position + SmallChange;
end;

procedure TMainForm.btnRotCLWClick(Sender: TObject);
begin
  with RotY do
    if Position >= Max then
      Position := Min + SmallChange
    else
      Position := Position + SmallChange;
end;

procedure TMainForm.btnRotCCLWClick(Sender: TObject);
begin
  with RotY do
    if Position <= Min then
      Position := Max - SmallChange
    else
      Position := Position - SmallChange;
end;

procedure TMainForm.ExitButtonClick(Sender: TObject);
begin
  Close;
end;

procedure TMainForm.SetUpNewPiece(const NewBlock: TObject);
begin
  if Assigned(NewBlock) then begin
    if Assigned(Piece) then
      Piece.Free;
    Piece := TBlock(NewBlock);
    Piece.Step := StrToInt(AdvOptions.edStepNo.Text);
    JustOne := False;
  end;
end;

procedure TMainForm.btnPointerClick(Sender: TObject);
var
  i                 : integer;
begin
  AdvOptions.ShowCoord(nil);
  JustOne := False;
  Piece.Free;
  Piece := nil;
  if Assigned(Macro) then begin
    with Macro do begin
      for i := 0 to Pred(Count) do begin
        TBlock(Items[i]).Free;
      end;
      Free;
    end;
    Macro := nil;
  end;
  LoadingMacro := False;

  PaintBox1.Cursor := crDefault;
  RedrawPicture(Sender);
  btnPointer.Down := True;
end;

procedure TMainForm.RefreshListBox;
begin
  ListBox1.Repaint;
end;

procedure TMainForm.Panel2MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if Button = mbRight then begin
    Color := clBtnFace;
    RefreshListBox;
  end;
end;

procedure TMainForm.Edit7MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  i                 : integer;
begin
  if Button = mbLeft then begin
    ClearCursorPiece;
    ColorIndicator := (Sender as TEdit).Color;
    if Assigned(Piece) then begin
      if LoadingMacro then begin
        for i := 0 to Pred(Macro.Count) do begin
          TBlock(Macro[i]).cl := ColorIndicator;
        end
      end
      else begin
        Piece.cl := ColorIndicator;
      end;
      if RecentCl.Count > 0 then
        RecentCl[0] := Pointer(ColorIndicator)
      else
        RecentCl.Add(Pointer(ColorIndicator));
    end;
    RedrawCursorPiece;
    RefreshListBox;
  end
  else if Button = mbRight then begin
    Color := (Sender as TEdit).Color;
    RefreshListBox;
  end;
end;

procedure TMainForm.TransparentMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if Button = mbLeft then begin
    ClearCursorPiece;
    btnTransparent.Down := not btnTransparent.Down;
    if Assigned(Piece) then
      Piece.Transp := btnTransparent.Down;
    RedrawCursorPiece;
    RefreshListBox;
    btnTransparent.Down := not btnTransparent.Down;
  end
end;

procedure TMainForm.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
const
  InKeyDown         : Boolean = False;
var
  Pt                : TPoint;
  i                 : integer;
  Dummy             : integer;
begin
  if InKeyDown then Exit;
  InKeyDown := True;
  if Key in [vk_left, vk_right, vk_up, vk_down, vk_prior, vk_next, vk_escape,
    vk_back, vk_return, vk_insert, vk_delete] then begin
    if Assigned(Piece) then begin
      ClearCursorPiece;
      case Key of
        vk_prior: begin
            if ssShift in Shift then
              Inc(Piece.pz, ResZFact)
            else
              Inc(Piece.pz, Piece.ph);
          end;
        vk_next: begin
            if (Piece.pz > 0) then begin
              if ssShift in Shift then
                Dec(Piece.pz, ResZFact)
              else
                Dec(Piece.pz, Piece.ph);
            end;
          end;
        vk_left: begin
            if ssShift in Shift then
              Dec(Piece.px, ResXYFact)
            else
              Dec(Piece.px, Piece.pl);
          end;
        vk_right: begin
            if ssShift in Shift then
              Inc(Piece.px, ResXYFact)
            else
              Inc(Piece.px, Piece.pl);
          end;
        vk_up: begin
            if ssShift in Shift then
              Dec(Piece.py, ResXYFact)
            else
              Dec(Piece.py, Piece.pb);
          end;
        vk_down: begin
            if ssShift in Shift then
              Inc(Piece.py, ResXYFact)
            else
              Inc(Piece.py, Piece.pb);
          end;
        vk_delete, vk_escape, vk_back:
          btnPointerClick(Sender);
        vk_return:
          PlacePiece(Dummy);
        vk_insert:
          PaintBox1MouseDown(Sender, mbRight, [ssRight], 0, 0);
      end;
      if Assigned(Piece) then
        Piece.pz := ZLevel(Piece.px, Piece.py, Piece.pl, Piece.pb);
      RedrawCursorPiece;
      if Assigned(Piece) then begin
        Pt := ScreenCoord(Point3D(Piece.px, Piece.py, 0), 0);
        Pt := PaintBox1.ClientToScreen(Pt);
      end
    end
    else begin
      case Key of
        vk_delete: begin
            for i := Pred(BlockList.Count) downto 0 do begin
              if TBlock(BlockList[i]).Selected then begin
                BlockList.UndoSave('-', BlockList[i]);
                TBlock(BlockList[i]).Free;
                BlockList.Delete(i);
              end
            end;
            AdvOptions.SelectionChanged;
            RedrawPicture(nil);
          end;
        vk_escape: begin
            for i := 0 to Pred(BlockList.Count) do
              TBlock(BlockList[i]).Selected := False;
            AdvOptions.SelectionChanged;
            RedrawPicture(nil);
          end;
        vk_return: begin
            if (ListBox1.ItemIndex >= 0) then begin
              ListBox1Click(ListBox1);
              Pt := ScreenCoord(Point3D(Piece.px, Piece.py, 0), 0);
              Pt := PaintBox1.ClientToScreen(Pt);
              SetCursorPos(Pt.x, Pt.y);
            end
          end;
        vk_prior: begin
            //            btnPrevPageClick(nil);
            ClearCursorPiece;
            for i := 0 to 13 do begin
              if ColorIndicator = Colors[i].Color then begin
                Dummy := i - 1;
                if Dummy < 0 then
                  Dummy := 13;
                ColorIndicator := Colors[Dummy].Color;
                break;
              end
            end;
            RedrawCursorPiece;
            RefreshListBox;
          end;
        vk_next: begin
            //            btnNextPageClick(nil);
            ClearCursorPiece;
            for i := 0 to 13 do begin
              if ColorIndicator = Colors[i].Color then begin
                Dummy := i + 1;
                if Dummy > 13 then
                  Dummy := 0;
                ColorIndicator := Colors[Dummy].Color;
                break;
              end
            end;
            RedrawCursorPiece;
            RefreshListBox;
          end;
        vk_left: begin
            if ssShift in Shift then
              OffsetX.Position := OffsetX.Position - OffsetX.SmallChange
            else if ssCtrl in Shift then begin
              Dummy := RotZ.Position - RotZ.SmallChange;
              if Dummy < RotZ.Min then
                Dummy := RotZ.Max;
              RotZ.Position := Dummy;
            end
            else if ssAlt in Shift then
              ZLiftOff.Position := ZLiftOff.Position - 1
            else
              btnPrevPageClick(nil);
          end;
        vk_right: begin
            if ssShift in Shift then
              OffsetX.Position := OffsetX.Position + OffsetX.SmallChange
            else if ssCtrl in Shift then begin
              Dummy := RotZ.Position + RotZ.SmallChange;
              if Dummy > RotZ.Max then
                Dummy := RotZ.Min;
              RotZ.Position := Dummy;
            end
            else if ssAlt in Shift then
              ZLiftOff.Position := ZLiftOff.Position + 1
            else
              btnNextPageClick(nil);
          end;
        vk_up: begin
            if ssShift in Shift then
              OffsetY.Position := OffsetY.Position - OffsetY.SmallChange
            else if ssCtrl in Shift then
              RotX.Position := RotX.Position + RotX.SmallChange
            else
              ListBox1.ItemIndex := ListBox1.ItemIndex - 1;
          end;
        vk_down: begin
            if ssShift in Shift then
              OffsetY.Position := OffsetY.Position + OffsetY.SmallChange
            else if ssCtrl in Shift then
              RotX.Position := RotX.Position - RotX.SmallChange
            else
              ListBox1.ItemIndex := ListBox1.ItemIndex + 1;
          end;
      end;
    end;
    Key := 0;
  end
  else begin
    if Key in [vk_home, vk_end, vk_f1..vk_f12,
      187, vk_add, 189, vk_subtract, vk_multiply, Ord('A')..Ord('Z')] then begin
      case Key of
        vk_home:
          btnHomeClick(Sender);
        vk_end, vk_f1:
          SetView(0, RotZ.Position);
        vk_f2:
          SetView(RotX.Position, 0);
        vk_f3:
          SetView(RotX.Position, 270);
        vk_f4: begin
            if ssAlt in Shift then Exit;
            SetView(RotX.Position, 90);
          end;
        vk_f5:
          SetView(RotX.Position, 180);
        vk_f6:
          SetView(70, 30);
        vk_f7:
          SetView(70, 150);
        vk_f8:
          SetView(70, 210);
        vk_f9:
          SetView(70, 330);
        vk_f10:
          SetView(90, RotZ.Position);
        vk_f12:
          SettingsSafe := not SettingsSafe;
        vk_add, 187:
          ScaleBar.Position := ScaleBar.Position - 1;
        vk_subtract, 189:
          ScaleBar.Position := ScaleBar.Position + 1;
        Ord('F'), Ord('G'), Ord('H'):
          mNewModelClick(Sender);
        Ord('M'):
          mSubAssemblyClick(Sender);
        Ord('P'):
          mSaveSelectedClick(Sender);
        Ord('S'):
          mSaveModelClick(Sender);
        Ord('C'), Ord('E'):
          btnClearClick(Sender);
        vk_multiply, Ord('T'): begin
            btnWireFrame.Click;
          end;
        Ord('B'): begin
            btnWireBase.Down := not btnWireBase.Down;
            btnWireBase.Click;
          end;
        Ord('O'): begin
            btnStuds.Down := not btnStuds.Down;
            btnStuds.Click;
          end;
      end;
      if Assigned(Piece) then begin
        Pt := ScreenCoord(Point3D(Piece.px, Piece.py, 0), 0);
        Pt := PaintBox1.ClientToScreen(Pt);
        SetCursorPos(Pt.x, Pt.y);
        RedrawCursorPiece;
      end;
      Key := 0;
    end;
  end;
  InKeyDown := False;
end;

function CreateBlockFromString(s: string): TBlock;
var
  i                 : integer;
  l, b, h           : integer;
  t                 : char;
  FileName,
    PartName,
    PartId          : string;
begin
  Result := nil;
  try
    i := Pos('|', s);
    if (i > 0) then begin
      PartId := Copy(s, i + 1, 255);
      s := Copy(s, 1, i - 1);
    end;
    if s[1] in ['A'..'Z'] then begin
      t := s[1];
      System.Delete(s, 1, 1);
    end
    else
      t := 'B';

    if (t = 'G') then begin
      i := Pos(',', s);
      FileName := Trim(Copy(s, 1, i - 1));
      PartName := Trim(Copy(s, i + 1, 255));
      l := 0;
      b := 0;
      h := 0;
    end
    else begin
      i := Pos('x', s);
      l := StrToInt(Copy(s, 1, i - 1));
      System.Delete(s, 1, i);
      i := Pos('x', s);
      b := StrToInt(Copy(s, 1, i - 1));
      System.Delete(s, 1, i);
      h := StrToInt(s);
    end;

    case t of
      'B':
        Result := TBlock.CreateBlock(0, 0, 0, l, b, h,
          clWhite, True, False, False, PartId);
      'T':
        Result := TRoof.CreateBlock(0, 0, 0, l, b, h,
          clWhite, True, False, False, PartId);
      'N':
        Result := TRoofTop.CreateBlock(0, 0, 0, l, b, h,
          clWhite, True, False, False, PartId);
      'E':
        Result := TRoofTopEnd.CreateBlock(0, 0, 0, l, b, h,
          clWhite, True, False, False, PartId);
      'C':
        Result := TRoofCorner.CreateBlock(0, 0, 0, l, b, h,
          clWhite, True, False, False, PartId);
      'I':
        Result := TRoofTopCorner.CreateBlock(0, 0, 0, l, b, h,
          clWhite, True, False, False, PartId);
      'R':
        Result := TRoundBlock.CreateBlock(0, 0, 0, l, b, h,
          clWhite, True, False, False, PartId);
      'W':
        Result := TWindow.CreateBlock(0, 0, 0, l, b, h,
          clWhite, True, False, False, PartId);
      'D':
        Result := TDoor.CreateBlock(0, 0, 0, l, b, h,
          clWhite, True, False, False, PartId);
      'O':
        Result := TWheel.CreateBlock(0, 0, 0, l, b, h,
          clWhite, True, False, False, PartId);
      'G':
        Result := TGeneralBlock.CreateBlock(0, 0, 0, l, b, h,
          clWhite, True, False, False, FileName,
          PartName, PartId);
    end;
  except
    Result := nil;
  end
end;

procedure TMainForm.ListBox1Click(Sender: TObject);
var
  s                 : string;
  s1                : string;
  s2                : string;
  i                 : integer;
  Pt                : TPoint;
begin
  ClearCursorPiece;
  btnPointerClick(nil);
  if (Abs(rx - pi / 2) >= 0.0) then
    with (Sender as TListBox) do begin
      s := Items[ItemIndex];

      if (Length(s) > 0) and (s[1] = 'M') then begin
        { open a Macro file }
        i := Pos('|', s);
        if (i > 0) then
          s := Copy(s, 1, i - 1);
        s := ExeLib + Trim(Copy(s, 2, 255)) + '.lgo';
        s1 := LoadSASPath;
        s2 := MyOpenDialog.FileName;
        OpenNamedFile(s, omSubAssembly);
        MyOpenDialog.FileName := s2;
        LoadSASPath := s1;
      end
      else begin
        SetUpNewPiece(CreateBlockFromString(s));

        if (ComboBox1.ItemIndex = 0) then begin
          Piece.cl := TColor(RecentCl[ItemIndex]);
        end
        else begin
          Piece.cl := ColorIndicator;
        end;

        i := Recent.IndexOf(s);
        if (i < 0) then begin
          Recent.Insert(0, s);
          RecentCl.Insert(0, Pointer(ColorIndicator));
          if (ComboBox1.ItemIndex = 0) then begin
            ListBox1.Items.Insert(0, s);
          end;
          if ListBox1.Tag > RcHeight then
            RcHeight := ListBox1.Tag;
        end
        else begin
          Recent.Move(i, 0);
          RecentCl.Move(i, 0);
          if (ComboBox1.ItemIndex = 0) then begin
            ListBox1.Items.Move(i, 0);
          end;
        end;
      end;

      if Assigned(Piece) then begin
        with Piece do begin
          px := LastX;                  //0;//999;
          py := LastY;                  //0;//999;
          pz := LastZ;                  //0;//999;
          Pt := ScreenCoord(Point3D(px, py, pz), 0);
          Pt := PaintBox1.ClientToScreen(Pt);
          SetCursorPos(Pt.x, Pt.y);
          st := not btnPieceStuds.Down;
          Transp := btnTransparent.Down;
          AdvOptions.ShowCoord(Piece);
          RedrawCursorPiece;
        end;
        btnPointer.Down := False;
      end;
    end;
  CalcTransform;
  //  CalcEye;
end;

procedure TMainForm.BSizeXKeyPress(Sender: TObject; var Key: Char);
var
  i                 : integer;
begin
  if Key = #13 then begin
    for i := 0 to Pred(BlockList.Count) do begin
      with TBlock(BlockList.Items[i]) do begin
        if bp then begin
          px := -(StrToInt(BSizeX.Text) div 2) * PFACTORXY;
          py := -(StrToInt(BSizeY.Text) div 2) * PFACTORXY;
          pl := (StrToInt(BSizeX.Text)) * PFACTORXY;
          pb := (StrToInt(BSizeY.Text)) * PFACTORXY;
          PartId := '';
          if ThickBase.Down then begin
            ph := 3 * PFACTORZ div 3;
            pz := -3 * PFACTORZ div 3;
          end
          else begin
            ph := 1 * PFACTORZ div 3;
            pz := -1 * PFACTORZ div 3;
          end;
          RedrawPicture(Sender);
          Exit;
        end
      end
    end;
    BlockList.Add(TBlock.CreateBlock(0, 0, 0, 0, 0, 0, GrayColor, True, True, False, ''));
    BSizeXKeyPress(Sender, Key);
  end
end;

procedure TMainForm.ThickBaseClick(Sender: TObject);
const
  Key               : char = #13;
begin
  BSizeXKeyPress(Sender, Key);
end;

function TMainForm.CheckModified: boolean;
begin
  Result := False;
  if Modified then begin
    case MessageDlg('The model has not been saved!' + #13#10 +
      'Do You want to save it now?',
      mtConfirmation, mbYesNoCancel, 0) of
      mrYes:
        if not SaveFile(SaveLGOPath, True) then
          Exit;
      mrNo: ;
      mrCancel: Exit;
    end;
  end;
  Result := True;
  Modified := False;
end;

procedure TMainForm.BreakUpAScene1Click(Sender: TObject);
var
  Source1           : TStringList;
  Source2           : TStringList;
  Dest              : TStringList;
  i                 : integer;
  Grp1              : integer;
  Grp2              : integer;
  GrpNum            : integer;
  OutDir            : string;
  Header            : string;

  function GetGroup(s: string): integer;
  var
    sl              : TStringList;
  begin
    Result := 0;
    if Length(s) > 10 then begin
      sl := TStringList.Create;
      try
        sl.CommaText := UpperCase(Trim(s));
        if sl[0] = 'G' then
          Result := StrToInt(sl[14])
        else if sl[0] <> '=' then
          Result := StrToInt(sl[12]);
      finally
        sl.Free;
      end
    end
  end;

begin
  MyOpenDialog.Title := 'Break Up Scene';
  MyOpenDialog.InitialDir := LoadLGOPath;

  if MyOpenDialog.Execute then begin
    GrpNum := 0;
    OutDir := MyOpenDialog.FileName;
    i := Pos('.LGO', OutDir);
    if i > 0 then
      Delete(OutDir, i, 255)
    else
      Exit;

    Source1 := TStringList.Create;
    Source2 := TStringList.Create;
    Dest := TStringList.Create;

    Source1.LoadFromFile(MyOpenDialog.FileName);
    if Source1[0][1] = '=' then begin
      Header := Source1[0];
      Source1.Delete(0);
    end
    else begin
      Header := '';
    end;

    while Source1.Count > 0 do begin
      if Length(Header) > 0 then
        Dest.Add(Header);
      Grp1 := GetGroup(Source1[0]);
      for i := 0 to Pred(Source1.Count) do begin
        Grp2 := GetGroup(Source1[i]);
        if Grp1 = Grp2 then
          Dest.Add(Source1[i])
        else
          Source2.Add(Source1[i]);
      end;
      if not DirectoryExists(OutDir) then
        Mkdir(OutDir);
      Dest.SaveToFile(Format('%s\%d.lgo', [OutDir, GrpNum]));
      Inc(GrpNum);
      Dest.Clear;
      Source1.Assign(Source2);
      Source2.Clear;
    end;
    try
    finally
      Dest.Free;
      Source2.Free;
      Source1.Free;
    end
  end
end;

procedure TMainForm.mNewmodelClick(Sender: TObject);
begin
  if CheckModified then begin
    OpenFile('Load a complete model', omNewModel);
  end
end;

procedure TMainForm.mSubAssemblyClick(Sender: TObject);
var
  f                 : string;
begin
  f := MyOpenDialog.FileName;
  if OpenFile('Load a subassembly', omSubAssembly) then
    btnPointer.Down := False;
  SetCurrentFile(f);
end;

procedure TMainForm.pumLoadPopup(Sender: TObject);
var
  mi                : TMenuItem;
  i                 : integer;
begin
  for i := Pred(pumLoad.Items.Count) downto 0 do begin
    if pumLoad.Items[i].Tag = -1 then begin
      pumLoad.Items.Delete(i);
    end
  end;
  for i := 0 to Min(14, Pred(MRUList.Count)) do begin
    mi := TMenuItem.Create(pumLoad);
    mi.Caption := MRUList[i];
    mi.OnClick := MRUClick;
    mi.Tag := -1;
    pumLoad.Items.Add(mi);
  end
end;

procedure TMainForm.MRUClick(Sender: TObject);
var
  f                 : string;
begin
  if (Sender is TMenuItem) then begin
    f := TMenuItem(Sender).Caption;
    OpenNamedFile(f, omSubAssembly);
  end
end;

procedure TMainForm.SetCurrentFile(f: string);
var
  q                 : integer;
  s                 : string;
begin
  s := Caption;
  q := Pos('-', s);
  if (q > 0) then
    s := Copy(s, 1, q - 2);

  if Length(f) > 0 then
    s := s + ' - ' + f;

  Caption := s;
  MyOpenDialog.FileName := f;
  dlgSaveFile.FileName := ExtractFileName(f);
end;

function NextInt(const s: string; var i: integer; const d: integer): integer;
var
  p                 : integer;
begin
  if i <= Length(s) then begin
    p := Pos(' ', Copy(s, i, 255)) + i - 1;
    if p = (i - 1) then
      p := Length(s) + 1;
    if s[i] in ['0'..'9', '-'] then begin
      Result := StrToInt(Copy(s, i, p - i));
      i := p + 1;
    end
    else begin                          { Found a field, but not number }
      Result := d;
    end
  end
  else begin
    Result := d;
  end
end;

function NextString(const s: string; var i: integer; const d: string): string;
var
  p                 : integer;
begin
  if i <= Length(s) then begin
    p := Pos(' ', Copy(s, i, 255)) + i - 1;
    if p = (i - 1) then
      p := Length(s) + 1;
    Result := Copy(s, i, p - i);
    i := p + 1;
  end
  else begin
    Result := d;
  end
end;

function TMainForm.OpenFile(t: string; Mode: TOpenMode): boolean;
begin
  Result := False;
  MyOpenDialog.Title := t;
  case Mode of
    omNewModel: MyOpenDialog.InitialDir := LoadLGOPath;
    omSubAssembly: MyOpenDialog.InitialDir := LoadSASPath;
  end;
  if MyOpenDialog.Execute then begin
    OpenNamedFile(MyOpenDialog.FileName, Mode);
    Result := True;
  end
end;

procedure TMainForm.OpenNamedFile(FileName: string; Mode: TOpenMode);
var
  i                 : integer;
  blk               : TBlock;
  sl                : TStringList;
  m0x, m0y, m0z     : integer;
  m1x, m1y, m1z     : integer;
  mStep             : integer;

begin
  sl := nil;

  m1x := 9999;
  m1y := 9999;
  m1z := 9999;
  m0x := -9999;
  m0y := -9999;
  m0z := -9999;

  btnPointerClick(nil);

  i := MRUList.IndexOf(FileName);
  if i = -1 then begin
    if MRUList.Count > 0 then
      MRUList.Insert(0, FileName)
    else
      MRUList.Add(FileName);
  end
  else begin
    MRUList.Move(i, 0);

    if MRUList.Count > 12 then
      MRUList.Delete(Pred(MRUList.Count));

  end;

  case Mode of
    omNewModel: begin
        LoadLGOPath := ExtractFilePath(FileName);
        if not DirectoryExists(LoadLGOPath) then
          LoadLGOPath := ExeLib + LoadLGOPath;
      end;
    omSubAssembly: begin
        LoadSASPath := ExtractFilePath(FileName);
        if not DirectoryExists(LoadSASPath) then
          LoadSASPath := ExeLib + LoadSASPath;
        LoadingMacro := true;
        Inc(NextGroup);
      end;
  end;

  InternalNoRedraw := True;
  try
    mStep := -9999;
    sl := TStringList.Create;
    NoRedraw := True;
    { read from file }

    if not LoadingMacro then begin
      btnClearClick(nil);
      TBlock(BlockList.Items[0]).Free;
      BlockList.Clear;
      Recent.Clear;
      RecentCl.Clear;
      mStep := 0;
    end
    else begin
      Macro := TBlockList.Create;
      mStep := BlockList.Step;
    end;

    SetCurrentFile(FileName);
    if Pos('.dat', LowerCase(FileName)) > 0 then begin
      LDraw2BlockCAD(FileName, BlockList);
    end
    else begin
      if LoadingMacro then begin
        Macro.LoadFromFile(FileName);

        for i := Pred(Macro.Count) downto 0 do begin
          blk := TBlock(Macro[i]);
          blk.Group := NextGroup;
          blk.Step := mStep;

          if blk.cl = 0 then
            blk.cl := ColorIndicator;

          if not blk.bp then begin
            m0x := Max(m0x, blk.px + blk.pl);
            m0y := Max(m0y, blk.py + blk.pb);
            m0z := Max(m0z, blk.pz + blk.ph);
            m1x := Min(m1x, blk.px);
            m1y := Min(m1y, blk.py);
            m1z := Min(m1z, blk.pz);
          end
          else begin
            Macro.Delete(i);
          end
        end
      end
      else begin
        BlockList.LoadFromFile(FileName);

        Settings.RotXPos := BlockList.sRotXP;
        Settings.RotZPos := BlockList.sRotZP;
        Settings.ScaleBarPos := BlockList.sScaleBP;
        Settings.OffsetXPos := BlockList.sOffsXP;
        Settings.OffsetYPos := BlockList.sOffsYP;
        RotX.Position := Settings.RotXPos;
        RotZ.Position := Settings.RotZPos;
        ScaleBar.Position := Settings.ScaleBarPos;
        OffsetX.Position := Settings.OffsetXPos;
        OffsetY.Position := Settings.OffsetYPos;
        Settings.StudsDown := (BlockList.sStuds <> 0);
        btnStuds.Down := not Settings.StudsDown;

        for i := 0 to Pred(BlockList.Count) do begin
          blk := TBlock(BlockList[i]);
          if blk.bp then begin
            BSizeX.Text := Format('%d', [blk.pl div PFACTORXY]);
            BSizeY.Text := Format('%d', [blk.pb div PFACTORXY]);
            if (blk.ph = (3 * PFACTORZ div 3)) then
              ThickBase.Down := True
            else
              ThickBase.Down := False;
            break;                      // No need to loop more
          end
        end

      end;
    end;
  finally
    InternalNoRedraw := False;
    sl.Free;
  end;
  BlockList.Step := mStep;
  AdvOptions.spStep.Value := mStep;
  RedrawPicture(nil);
  if LoadingMacro then begin
    Macro.Step := mStep;
    SetUpNewPiece(CreateBlockFromString(Format(' %dx%dx%d',
      [(m0x - m1x) div PFACTORXY,
      (m0y - m1y) div PFACTORXY,
        (m0z - m1z) * 3 div PFACTORZ])));
  end;
  ZLiftOff.Position := Cutting.Dlg.ZMax;
end;

{ Save as LDraw thanks to Tore Eriksson }

const
  TxtRot            : array[0..7] of string = (
    '  1   0  0    0  1  0   0   0  1',
    '  0   0 -1    0  1  0   1   0  0',
    ' -1   0  0    0  1  0   0   0 -1',
    '  0   0  1    0  1  0  -1   0  0',
    '  0.7 0 -0.7  0  1  0   0.7 0  0.7',
    ' -0.7 0 -0.7  0  1  0   0.7 0 -0.7',
    ' -0.7 0  0.7  0  1  0  -0.7 0 -0.7',
    '  0.7 0  0.7  0  1  0  -0.7 0  0.7'
    );

function TMainForm.ColorMatch(c: TColor): integer;
var
  i                 : integer;
  d                 : TMyFloat;
  t                 : TMyFloat;
  R, G, B           : integer;
  dx                : integer;
begin
  for i := 0 to 13 do begin
    if (c = Colors[i].Color) then begin
      Result := Colors[i].Tag;
      Exit;
    end;
  end;
  c := ColorToRGB(c);
  dx := 15;
  d := Sqr(255) * 3 + 1;
  B := (integer(c) and $FF0000) shr 16;
  G := (integer(c) and $FF00) shr 8;
  R := (integer(c) and $FF);
  for i := 0 to High(MatchColor) do begin
    t := Sqr(R - MatchColor[i].R) + Sqr(G - MatchColor[i].G) + Sqr(B - MatchColor[i].B);
    if (t < d) then begin
      d := t;
      dx := i;
    end
  end;
  Result := MatchColor[dx].LDcolor;
end;

function InvColorMatch(c: integer): TColor;
var
  i                 : integer;
begin
  Result := clWhite;
  for i := Low(MatchColor) to High(MatchColor) do begin
    if MatchColor[i].LDColor = c then begin
      Result := RGB(MatchColor[i].R, MatchColor[i].G, MatchColor[i].B);
    end
  end
end;

function TMainForm.ColorMatch2(c: integer): TColor;
var
  i                 : integer;
  dx                : integer;
begin
  dx := 0;
  for i := 0 to High(MatchColor) do begin
    if MatchColor[i].LDColor = c then begin
      dx := i;
      Break;
    end
  end;
  Result := RGB(MatchColor[dx].R, MatchColor[dx].G, MatchColor[dx].B);
end;

procedure InitializeLDrawCross;
var
  i                 : integer;
  p                 : integer;
  pt                : TLDrawRecord;
  s                 : string;
begin
  if Assigned(LdrawCross) then begin
    for i := 0 to Pred(LDrawCross.Count) do begin
      LDrawCross.Objects[i].Free;
    end;
    LDrawCross.Free;
  end;
  LDrawCross := TStringList.Create;
  LDrawCross.LoadFromFile(ExeLib + 'bc2ld.lst');
  for i := Pred(LDrawCross.Count) downto 0 do begin
    s := LDrawCross[i];
    if (Length(s) < 24) or (s[1] = ';') then
      LDrawCross.Delete(i);
  end;
  for i := 0 to Pred(LDrawCross.Count) do begin
    s := LDrawCross[i];
    pt := TLDrawRecord.Create;
    LDrawCross.Objects[i] := TObject(pt);
    with pt do begin
      t := s[1];
      p := 3;
      b := NextInt(s, p, 0);
      l := NextInt(s, p, 0);
      h := NextInt(s, p, 0);
      st := NextInt(s, p, 0);
      cl := NextInt(s, p, 0);
      xOffset := NextInt(s, p, 0);
      yOffset := NextInt(s, p, 0);
      zOffset := NextInt(s, p, 0);
      RotOffset := NextInt(s, p, 0);
      PartId := NextString(s, p, '');
      PartId := Copy(PartId, 1, Length(PartId) - 4); { skip .DAT }
      LDrawPatch := NextInt(s, p, 0);
      FilNam := NextString(s, p, '');
      PrtNam := NextString(s, p, '');
    end;
  end;
end;

function CrossStringFromData(d: TLDrawRecord): string;
begin
  with d do
    Result := Format('%s %d %d %d %d %d %d %d %d %d %s.DAT %d %s %s',
      [t, b, l, h, st, cl, xOffset, yOffset, zOffset, RotOffset,
      PartID, LDrawPatch, FilNam, PrtNam]);
end;

procedure SaveLDrawCross;
begin
  if Assigned(LDrawCross) then begin
    LDrawCross.SaveToFile(ExeLib + 'bc2ld.lst');
  end
end;

procedure TMainForm.SaveAsLDraw(var f: TextFile);

  function Identify(const b: TBlock;
    var xo, yo, zo, ro: integer;
    var p: string): boolean;
  var
    i               : integer;
    c, n            : TLDrawRecord;
    s               : string;
    AddToList       : Boolean;
  begin
    c := nil;
    Result := False;
    AddToList := False;
    if (Length(b.PartID) > 0) then begin
      for i := 0 to Pred(LDrawCross.Count) do begin
        c := TLDrawRecord(LDrawCross.Objects[i]);
        if (CompareText(b.PartID, c.PartID) = 0) and
          (b.LDrawPatch = c.LDrawPatch) and
          ((((b.pb div PFACTORXY) = c.b) and ((b.pl div PFACTORXY) = c.l)) or
          (((b.pb div PFACTORXY) = c.l) and ((b.pl div PFACTORXY) = c.b))) and
          (b.st = (c.st = 1)) then begin
          Result := True;
          Break;
        end
      end;
      if (Result = False) then begin    { List does not contain this piece }
        AddToList := True;
      end
    end;
    if (Result = False) then begin
      for i := 0 to Pred(LDrawCross.Count) do begin
        c := TLDrawRecord(LDrawCross.Objects[i]);
        if (b.t <> c.t) or
          (b.st <> (c.st = 1)) or
          ((b.ph div (PFACTORZ div 3)) <> c.h) or
          (b.LDrawPatch <> c.LDrawPatch) then
          continue;

        if (b.t = 'G') then begin
          if (CompareText(TGeneralBlock(b).FilNam, c.FilNam) = 0) and
            (CompareText(TGeneralBlock(b).PrtNam, c.PrtNam) = 0) then begin
            Result := True;
            Break;
          end
        end
        else begin
          if (((b.pb div PFACTORXY) = c.b) and ((b.pl div PFACTORXY) = c.l)) or
            (((b.pb div PFACTORXY) = c.l) and ((b.pl div PFACTORXY) = c.b)) then begin
            Result := True;
            AddToList := False;
            Break;
          end
        end
      end
    end;
    if AddToList then begin
      n := TLDrawRecord.Create;
      if (Result = False) then begin
        n.t := b.t;
        n.b := b.pb div PFACTORXY;
        n.l := b.pl div PFACTORXY;
        n.h := b.ph div PFACTORZ * 3;
        if b.st then n.st := 1;
        n.cl := 16;
        n.xOffset := 0;
        n.yOffset := 0;
        n.zOffset := 0;
        n.RotOffset := 0;
        n.PartId := b.PartID;
        n.LDrawPatch := b.LDrawPatch;
        if b.t = 'G' then begin
          n.FilNam := TGeneralBlock(b).FilNam;
          n.PrtNam := TGeneralBlock(b).PrtNam;
        end
        else begin
          n.FilNam := '';
          n.PrtNam := '';
        end
      end
      else begin                        { Found something that matches dimensions }
        if Assigned(c) then begin
          n.t := c.t;
          n.b := c.b;
          n.l := c.l;
          n.h := c.h;
          n.st := c.st;
          n.cl := c.cl;
          n.xOffset := c.xOffset;
          n.yOffset := c.yOffset;
          n.zOffset := c.zOffset;
          n.RotOffset := c.RotOffset;
          n.PartId := b.PartID;
          n.LDrawPatch := b.LDrawPatch;
          if b.t = 'G' then begin
            n.FilNam := TGeneralBlock(b).FilNam;
            n.PrtNam := TGeneralBlock(b).PrtNam;
          end
          else begin
            n.FilNam := '';
            n.PrtNam := '';
          end
        end
      end;
      s := CrossStringFromData(n);
      LDrawCross.AddObject(s, n);
      SaveLDrawCross;
      c := n;
      Result := True;
    end;
    if (Result = True) then begin
      xo := c.xOffset;
      yo := c.yOffset;
      zo := c.zOffset;
      ro := c.RotOffset;
      p := c.PartId;
    end
  end;

var
  i                 : integer;
  c, x, y,
    z, Rot          : integer;
  xOffs, yOffs, zOffs, RotOffs: integer;

begin
  InitializeLdrawCross;
  (* needs rework to handle the block.xOffset etc *)
  with BlockList do begin
    for i := 0 to Pred(Count) do begin
      with TBlock(Items[i]) do begin
        if t = ' ' then
          t := 'B';
        c := ColorMatch(cl);
        if Transp then
          c := c or 32;
        x := 10 * (px * 2 + pl) div PFACTORXY;
        z := -10 * (py * 2 + pb) div PFACTORXY;
        y := -8 * 3 * (pz + ph) div PFACTORZ;
        Rot := Dir;
        if Identify(TBlock(Items[i]), xOffs, yOffs, zOffs, RotOffs, Partid) then begin
          y := y + yOffs;
          Rot := (Rot + (RotOffs and 3)) mod 4;
          case Rot of
            0: begin
                x := x - xOffs;
                z := z + zOffs;
              end;
            1: begin
                z := z - xOffs;
                x := x - zOffs;
              end;
            2: begin
                x := x + xOffs;
                z := z - zOffs;
              end;
            3: begin
                z := z + xOffs;
                x := x + zOffs;
              end;
          end;
          writeln(f, Format('1 %d %d %d %d %s %s',
            [c, x, y, z, txtrot[Rot + (RotOffs and 4)], PartId + '.dat']));
        end
        else begin
          { piece not found }
        end;
        { wheel hack }
        if (PartId = '497') or (Partid = '7039') or (Partid = 'wheel2') then
          writeln(f, Format('1 %d %d %d %d %s %s',
            [0, x, y, z, txtrot[Rot], '3483.dat']));
        if (PartId = '4624') then
          writeln(f, Format('1 %d %d %d %d %s %s',
            [0, x, y, z, txtrot[Rot], '3641.dat']));
      end
    end
  end
end;

procedure TMainForm.FindCenter(var bx0, by0, bz0, bx1, by1, bz1, cx, cy, cz: integer);
var
  i                 : integer;
begin
  bx0 := 99999;
  by0 := 99999;
  bz0 := 99999;
  bx1 := -99999;
  by1 := -99999;
  bz1 := -99999;
  for i := 0 to Pred(BlockList.Count) do begin
    bx0 := Min(bx0, TBlock(BlockList[i]).px);
    by0 := Min(by0, TBlock(BlockList[i]).py);
    bz0 := Min(bz0, TBlock(BlockList[i]).pz);
    bx1 := Max(bx1, TBlock(BlockList[i]).px + TBlock(BlockList[i]).pl);
    by1 := Max(by1, TBlock(BlockList[i]).py + TBlock(BlockList[i]).pb);
    bz1 := Max(bz1, TBlock(BlockList[i]).pz + TBlock(BlockList[i]).ph);
  end;
  cx := bx0 + (bx1 - bx0) div 2;
  cy := by0 + (by1 - by0) div 2;
  cz := bz0 + (bz1 - bz0) div 2;
end;

procedure TMainForm.SpeedButton1Click(Sender: TObject);
var
  f                 : TextFile;
  cmd               : string;
  d                 : string;
  st                : string;
  Sc                : TMyFloat;
begin
  AssignFile(f, LDrawLib + '\' + LDrawTest);
  Rewrite(f);
  SaveAsLdraw(f);
  CloseFile(f);
  d := GetCurrentDir;
  SetCurrentDir(LDrawLib);
  st := '';
  if FastStuds2.Checked then
    st := st + '-FS ';
  st := st + Format('-O%d,%d ', [Round(Settings.xBase - PaintBox1.Width div 2),
    Round(Settings.yBase - PaintBox1.Height div 2 - 70)]);
  st := st + Format('-a%.3g,%.3g,%.3g,%.3g,%.3g,%.3g,%.3g,%.3g,%.3g ',
    [cos(2 * pi - rz), 0.0, sin(2 * pi - rz),
    sin(2 * pi - rz) * sin(-rx + pi / 2), cos(-rx + pi / 2), -sin(-rx + pi / 2) * cos(2 * pi - rz),
      -sin(2 * pi - rz) * cos(-rx + pi / 2), sin(-rx + pi / 2), cos(-rx + pi / 2) * cos(2 * pi - rz)]);
  Sc := Settings.Scale;
  if CompareText(Copy(LdrawProg, 1, 5), 'ldraw') = 0 then
    Sc := Sc / 1.5;

  cmd := Format('%s  -s%g -b%d %s %s',
    [LDrawProg, Sc, ColorMatch(Color), st, LdrawTest]);
  WinExecNoWait(cmd, LDrawLib, SW_MAXIMIZE);
  SetCurrentDir(d);
end;

procedure TMainForm.L2povClick(Sender: TObject);
var
  f                 : TextFile;
  cmd               : string;
  d                 : string;
  s                 : string;
  cl                : TColor;
  bx0, by0, bz0, bx1, by1, bz1, lcx, lcy, lcz: integer;
  bm                : TMyFloat;
begin

  FindCenter(bx0, by0, bz0, bx1, by1, bz1, lcx, lcy, lcz);
  bm := Exp(Ln(rMax(Abs(bx1 - bx0), rMax(Abs(by1 - by0), Abs(bz1 - bz0)))) / 3.0) * 9;

  AssignFile(f, LDrawLib + '\' + LDrawTest);
  Rewrite(f);
  SaveAsLdraw(f);
  CloseFile(f);
  d := GetCurrentDir;
  SetCurrentDir(LDrawLib);
  s := '';
  cmd := L2PCmd + ' ' + s;
  WinExecAndWait(cmd, LDrawLib, SW_MINIMIZE);
  cl := ColorToRGB(Color);
  CalcTransform;
  AssignFile(f, LDrawLib + '\BC_test.pov');
  Rewrite(f);

  WriteLn(f, '#version 3.0');
  WriteLn(f, '#include "lg_color.inc"');
  WriteLn(f, '#include "lg_defs.inc"');
  WriteLn(f);
  WriteLn(f, '#include "test.inc"');
  WriteLn(f);
  WriteLn(f, Format('background { color rgb <%g,%g,%g>}',
    [GetRValue(cl) / 255, GetGValue(cl) / 255, GetBValue(cl) / 255]));
  WriteLn(f, '/*object {');
  WriteLn(f, ' plane { z, -1*LG_TOP_HEIGHT } // locate the plane below a baseplate');
  WriteLn(f, '  pigment {color DarkGreen}');
  WriteLn(f, '}*/');
  WriteLn(f);
  WriteLn(f, 'light_source { <-50, -35, 45> color White }');
  WriteLn(f, 'light_source { <20, 60, 50> color White }');
  WriteLn(f, 'light_source { <-45, -45, 30> color White }');
  WriteLn(f);
  WriteLn(f, 'camera {');
  WriteLn(f, Format(' location <%g*LG_BRICK_WIDTH, %g*LG_BRICK_WIDTH, %g*LG_BRICK_HEIGHT>',
    [bm / Settings.Scale * sz * sx, -bm / Settings.Scale * cz * sx, bm / Settings.Scale * cx]));
  WriteLn(f, ' angle 20');
  WriteLn(f, ' sky <0, 0, 1>');
  WriteLn(f, ' up <0, 1, 0>');
  WriteLn(f, Format(' look_at <%d*LG_BRICK_WIDTH, %d*LG_BRICK_WIDTH, %d*LG_BRICK_HEIGHT>',
    [-lcy div 20, lcx div 20, lcz div (3 * 8)]));
  WriteLn(f, '}');

  CloseFile(f);
  s := Format('%s +IBC_test.pov -V +W%d +H%d', [PovRayEng, 320, 240]);
  WinExecNoWait(s, LDrawLib, SW_SHOWNORMAL);
  SetCurrentDir(d);
end;

procedure TMainForm.L3povClick(Sender: TObject);
var
  f                 : TextFile;
  cmd               : string;
  d                 : string;
  s                 : string;
  sl                : TStringList;
  i                 : integer;
  cl                : TColor;
  bx0, by0, bz0, bx1, by1, bz1, lcx, lcy, lcz: integer;
begin
  FindCenter(bx0, by0, bz0, bx1, by1, bz1, lcx, lcy, lcz);
  AssignFile(f, LDrawLib + '\' + LDrawTest);
  Rewrite(f);
  SaveAsLdraw(f);
  CloseFile(f);
  d := GetCurrentDir;
  SetCurrentDir(LDrawLib);
  //  s := Format('-cg%g,%g,%g', [rx*180.0/pi, rz*180.0/pi, 0.0]);
  s := '';
  cmd := L3PCmd + ' ' + s;
  WinExecAndWait(cmd, LDrawLib, SW_MINIMIZE);

  sl := TStringList.Create;
  try
    sl.LoadFromFile(LDrawLib + '\test.pov');

    for i := 0 to Pred(sl.Count) do begin
      if Copy(Trim(sl[i]), 1, 15) = '#declare Color3' then begin
        sl[i + 1] := 'pigment { rgb 0.7*<0.1,0.5,0.2> }';
      end;

      if Copy(Trim(sl[i]), 1, 16) = '#declare Color10' then begin
        sl[i + 1] := 'pigment { rgb <0.0,1,0.0392157> }';
      end;

      if Copy(Trim(sl[i]), 1, 16) = '#declare Color42' then begin
        sl[i + 1] := 'pigment { rgbf <0.0,1,0.0392157,0.85> }';
      end;

      if Copy(Trim(sl[i]), 1, 12) = '#declare PCT' then begin
        sl[i] := '';
      end;

    end;

    i := sl.IndexOf('// Background:');
    if (i >= 0) then begin
      Inc(i);
      cl := ColorToRGB(Color);
      if Pos('background', sl[i]) > 0 then begin
        sl[i] := Format('background { color rgb <%g,%g,%g>}',
          [GetRValue(cl) / 255, GetGValue(cl) / 255, GetBValue(cl) / 255]);
      end
    end;
    i := sl.IndexOf('camera {');
    if (i >= 0) then begin
      Inc(i);
      if Pos('PCT', sl[i]) > 0 then begin
        sl[i] := '    #declare PCT = 300 // Percentage further away';
      end;
      while (i < sl.Count) and (Pos('location', sl[i]) = 0) do
        Inc(i);
      CalcTransform;
      if (Pos('vaxis_rotate', sl[i]) > 0) then
        sl.Delete(i);
      sl[i] := Format('    location <%g,%g,%g>',
        [-1000.0 / Settings.Scale * cz * sx,
        -1000.0 / Settings.Scale * cx,
          1000.0 / Settings.Scale * sz * sx
          ]);
      while (i < sl.Count) and
        (Pos('angle', sl[i]) = 0) and
        (Pos('}', sl[i]) = 0) do begin
        if Pos('look_at', sl[i]) > 0 then begin
          sl[i] := Format('    look_at <%d, %d, %d>', [lcx, -lcz, -lcy]);
        end;
        Inc(i);
      end;
      if Pos('angle', sl[i]) > 0 then
        sl[i] := '    angle 25'
      else
        sl.Insert(i, '    angle 25');
    end;
    sl.SaveToFile(LDrawLib + '\test.pov');
  finally
    sl.Free;
  end;
  s := Format('%s +Itest.pov -V +W%d +H%d', [PovRayEng, 320, 240]);
  WinExecNoWait(s, LDrawLib, SW_SHOWNORMAL);
  SetCurrentDir(d);
end;

procedure TMainForm.pumSavePopup(Sender: TObject);
begin
  mSaveSelected.Enabled := (FirstSelected <> -1);
end;

procedure TMainForm.mSaveModelClick(Sender: TObject);
begin
  dlgSaveFile.FileName := MyOpenDialog.FileName;
  SaveFile(SaveLGOPath, True);
end;

procedure TMainForm.mSaveSelectedClick(Sender: TObject);
begin
  dlgSaveFile.FileName := '';
  SaveFile(SaveSASPath, False);
end;

function TMainForm.SaveFile(var Path: string; SaveAll: Boolean): Boolean;
var
  f                 : textfile;
  i                 : integer;
  s                 : string;
begin
  Result := False;
  s := dlgSaveFile.FileName;
  i := Length(s) - 3;
  if (i > 0) and (s[i] = '.') then
    dlgSaveFile.FileName := Copy(s, 1, i - 1);
  if (Length(Path) > 0) then
    dlgSaveFile.InitialDir := Path;
  if SaveAll then
    dlgSaveFile.Title := 'Save model as...'
  else
    dlgSaveFile.Title := 'Save selected parts as...';

  if dlgSaveFile.Execute then begin
    Path := ExtractFilePath(dlgSaveFile.FileName);
    SetCurrentFile(dlgSaveFile.FileName);
    { write to file }
    AssignFile(f, Path + '\' + dlgSaveFile.FileName);
    Rewrite(f);
    if CompareText(ExtractFileExt(dlgSaveFile.FileName), '.DAT') = 0 then begin
      SaveAsLDraw(f);
    end
    else begin
      writeln(f, Format('= %d %d %d %d %d %d 1',
        [RotX.Position, RotZ.Position, ScaleBar.Position,
        OffsetX.Position, OffsetY.Position,
          integer(not btnStuds.Down)]));
      with BlockList do begin
        for i := 0 to Pred(Count) do begin
          with TBlock(Items[i]) do begin
            if (Selected or SaveAll) then begin
              if (t = 'G') then
                with TGeneralBlock(Items[i]) do
                  writeln(f, Format('%s %d %d %d %d %d %d %d %d %d %d %d %s %s %d %s %d',
                    [t, px, py, pz, pl, pb, ph, cl,
                    integer(st), integer(bp), Dir, integer(Transp),
                      FilNam, PrtNam, Group, PartID, Step]))
              else
                writeln(f, Format('%s %d %d %d %d %d %d %d %d %d %d %d %d %s %d',
                  [t, px, py, pz, pl, pb, ph, cl,
                  integer(st), integer(bp), Dir, integer(Transp),
                    Group, PartID, Step]));
            end
          end
        end
      end;
      Modified := Modified and not SaveAll;
    end;
    CloseFile(f);
    Settings.RotXPos := RotX.Position;
    Settings.RotZPos := RotZ.Position;
    Settings.ScaleBarPos := ScaleBar.Position;
    Settings.OffsetXPos := OffsetX.Position;
    Settings.OffsetYPos := OffsetY.Position;
    Settings.StudsDown := not btnStuds.Down;
    //    Path := ExtractFilePath(dlgSaveFile.FileName);
    Result := True;
  end
end;

const
  LiftOffChanging   : Boolean = False;

procedure TMainForm.btnClearClick(Sender: TObject);
const
  Key               : char = #13;
var
  i                 : integer;
begin
  if CheckModified then begin
    SetCurrentFile('');
    with BlockList do begin
      for i := 0 to Pred(Count) do begin
        TBlock(Items[i]).Free;
      end;
      Clear;
      Add(TBlock.CreateBlock(-8, -4, -1, 16, 8, 1, GrayColor, not btnPieceStuds.Down, True, False, '3865'));
      BSizeXKeyPress(Sender, Key);
    end;

    ZCutOff := Cutting.Dlg.ZMax;
    ZLiftOff.Position := ZCutOff;
    btnUndo.Enabled := False;
    btnRedo.Enabled := False;
    RedrawPicture(Sender);
    Recent.Clear;
    RecentCl.Clear;
    if (ComboBox1.ItemIndex = 0) then
      ListBox1.Items.Clear;
    RcHeight := 40;
    Modified := False;
  end
end;

procedure TMainForm.ZLiftOffChange(Sender: TObject);
var
  NewZ              : integer;
begin
  if LiftOffChanging = False then begin
    LiftOffChanging := True;
    try

      NewZ := ZLiftOff.Position;
      if NewZ < ZCutOff then
        if (zCutOff - NewZ) > 1 then
          NewZ := Cutting.Dlg.ZMin
        else
          NewZ := Cutting.Dlg.ZDown
      else if (NewZ - zCutOff) > 1 then
        NewZ := Cutting.Dlg.ZMax
      else
        NewZ := Cutting.Dlg.ZUp;
      ZLiftOff.Position := NewZ;

      ZCutOff := ZLiftOff.Position;
      lblZLiftOff.Caption := Format('%d', [ZCutOff]);
      RedrawPicture(Sender);
    finally
      LiftOffChanging := False;
    end;
  end;
end;

procedure TMainForm.btnPieceStudsClick(Sender: TObject);
begin
  if Assigned(Piece) then Piece.st := not btnPieceStuds.Down;
  RefreshListBox;
end;

procedure TMainForm.btnPrintClick(Sender: TObject);
var
  sScale, sXBase, sYBase: TMyFloat;
  f                 : integer;
  Pts               : array[0..2] of TPoint;
  w, h              : integer;
  m, lm             : integer;
  PCanvas           : TDrawObject;
begin
  if PrintDialog1.Execute then begin
    sScale := Settings.Scale;
    sXBase := Settings.xBase;
    sYBase := Settings.yBase;
    with Printer do begin
      w := PageWidth;
      h := PageHeight;
      f := (w div PaintBox1.Width);
      Settings.Scale := f * Settings.Scale;

      Settings.xBase := Round(w / 2.0) - OffsetX.Position * f;
      Settings.yBase := Round(h / 2.0) - OffsetY.Position * f;

      Transform([Point3D(0, 0, 0), Point3D(0, 0, 3), Point3D(0, 0, PFACTORXY)], Pts, 0);
      zx := Pts[1].x - Pts[0].x;
      zy := Pts[1].y - Pts[0].y;

      zx1 := Pts[2].x - Pts[0].x;
      zy1 := Pts[2].y - Pts[0].y;

      SetStudsIncrement;

      m := 3 * w div 100;
      lm := m + m;

      BeginDoc;
      PCanvas := TDrawObject.Create(Printer.Canvas);
      try
        Printer.Canvas.Brush.Color := clWhite;
        Printer.Canvas.Rectangle(lm, m, w - m, h - m);
        Printer.Canvas.TextOut(lm + 5, m + 5, MyOpenDialog.FileName);
        BlockList.Draw(PCanvas, False);
      finally
        PCanvas.Free;
      end;
      EndDoc;

    end;
    Settings.yBase := sYBase;
    Settings.xBase := sXBase;
    Settings.Scale := sScale;
    Transform([Point3D(0, 0, 0), Point3D(0, 0, 3), Point3D(0, 0, PFACTORXY)], Pts, 0);
    zx := Pts[1].x - Pts[0].x;
    zy := Pts[1].y - Pts[0].y;

    zx1 := Pts[2].x - Pts[0].x;
    zy1 := Pts[2].y - Pts[0].y;

    SetStudsIncrement;

  end;
end;

procedure TMainForm.ListBox1DrawItem(Control: TWinControl; Index: Integer;
  Rect: TRect; State: TOwnerDrawState);
var
  b                 : TBlock;
  Pts               : array[0..3] of TPoint;
  MidP              : TPoint;
  MinP              : TPoint;
  MaxP              : TPoint;
  sb                : Boolean;
  sWF               : boolean;
  s                 : string;
  i                 : integer;
  lTag              : integer;
  sLevel            : integer;
  WorkImg           : TImageList;
  png               : TPngObject;
  LBCanvas          : TDrawObject;
  tbl               : TBlockList;
  NewScale          : TMyFloat;
begin
  if InternalNoRedrawListBox then
    Exit;

  LstBmp.Height := Rect.Bottom - Rect.Top;
  LstBmp.Width := Rect.Right - Rect.Left;
  LBCanvas := TDrawObject.Create(LstBmp);
  try
    with (Control as TListBox), LstBmp do begin
      lTag := Min(255, Tag);

      if odSelected in State then
        Canvas.Brush.Color := clBtnShadow
      else
        Canvas.Brush.Color := clBtnFace //MainForm.Color //clBtnFace
        ;
      Canvas.FillRect(Canvas.ClipRect);
      Canvas.Pen.Color := clGray;
      Canvas.Rectangle(0, 0, Width, Height);
      Canvas.Pen.Color := clBlack;

      s := Items[Index];
      if (Length(s) > 0) and (s[1] = 'M') then begin { Macro }
        i := Pos('|', s);
        if i > 0 then
          s := Copy(s, 1, i - 1);
        s := Trim(Copy(s, 2, 255));
        tbl := TBlockList.Create;
        try
          tbl.LoadFromFile(ExeLib + s + '.lgo');
          for i := Pred(tbl.Count) downto 0 do begin

            TBlock(tbl[i]).px := TBlock(tbl[i]).px - tbl.bx;
            TBlock(tbl[i]).py := TBlock(tbl[i]).py - tbl.by;
            TBlock(tbl[i]).pz := TBlock(tbl[i]).pz - tbl.bz;

            TBlock(tbl[i]).Step := 0;

            if TBlock(tbl[i]).cl = 0 then begin
              TBlock(tbl[i]).cl := ColorIndicator;
            end;

            if TBlock(tbl[i]).bp then begin
              tbl.Delete(i);
            end;
          end;

          tbl.bx := 0;
          tbl.by := 0;
          tbl.bz := 0;

          sLevel := DetailLevel;
          DetailLevel := 99;
          SaveTransform;
          sb := btnStuds.Down;
          btnStuds.Down := btnPieceStuds.Down;
          sWF := WireFrame;
          WireFrame := False;
          try
            Settings.xBase := 0.0;
            Settings.yBase := 0.0;
            Settings.Scale := single(PgScale[CurPage]);
            rx := 60 * DEG2RAD;
            rz := 30 * DEG2RAD;
            ry := 0;
            CalcTransform;
            //            CalcEye;

                        { Center piece in ListBox item Rect }

            MinP := ScreenCoord(Point3D(tbl.bx, tbl.by, tbl.bz), 0);
            MaxP := ScreenCoord(Point3D(tbl.bx + tbl.bl, tbl.by + tbl.bb, tbl.bz + tbl.bh), 0);
            NewScale := lTag * 0.9 / Abs(MaxP.x - MinP.x) * single(PgScale[CurPage]);
            if NewScale < Settings.Scale then
              Settings.Scale := NewScale;

            MinP := ScreenCoord(Point3D(tbl.bx, tbl.by + tbl.bb, tbl.bz), 0);
            MaxP := ScreenCoord(Point3D(tbl.bx + tbl.bl, tbl.by, tbl.bz + tbl.bh), 0);
            NewScale := lTag * 0.9 / Abs(MaxP.y - MinP.y) * single(PgScale[CurPage]);
            if NewScale < Settings.Scale then
              Settings.Scale := NewScale;

            MidP := ScreenCoord(Point3D(tbl.bx + (tbl.bl div 2), tbl.by + (tbl.bb div 2), tbl.bz + (tbl.bh div 2)), 0);

            Settings.xBase := Max(1, (ListBox1.ClientWidth div 2) - MidP.x);
            Settings.yBase := Max(2, (lTag div 2) - MidP.y);
            { --------------------------------- }

            Transform([Point3D(0, 0, 0), Point3D(0, 0, 3), Point3D(0, 0, PFACTORZ)], Pts, 0);
            zx := Pts[1].x - Pts[0].x;
            zy := Pts[1].y - Pts[0].y;

            zx1 := Pts[2].x - Pts[0].x;
            zy1 := Pts[2].y - Pts[0].y;

            SetStudsIncrement;
            tbl.Draw(LBCanvas, True);
          finally
            btnStuds.Down := sb;
            RecallTransform;
            DetailLevel := sLevel;
            WireFrame := sWF;
          end
        finally
          tbl.Free;
        end;
      end
      else begin                        { Ordinary brick }
        try
          b := CreateBlockFromString(Items[Index]);
          b.st := True;

          if (ComboBox1.ItemIndex = 0) and (Index < RecentCl.Count) then
            b.cl := TColor(RecentCl[Index])
          else
            b.cl := ColorIndicator;

          b.Transp := btnTransparent.Down;
          sLevel := DetailLevel;
          DetailLevel := 99;
          SaveTransform;
          sb := btnStuds.Down;
          btnStuds.Down := btnPieceStuds.Down;
          sWF := WireFrame;
          WireFrame := False;
          try
            Settings.xBase := 0.0;
            Settings.yBase := 0.0;
            Settings.Scale := single(PgScale[CurPage]); //0.50;
            rx := 60 * DEG2RAD;
            rz := 30 * DEG2RAD;
            ry := 0;
            CalcTransform;
            //            CalcEye;

                        { Center piece in ListBox item Rect }
            MinP := ScreenCoord(Point3D(b.px, b.py, b.pz), 0);
            MaxP := ScreenCoord(Point3D(b.px + b.pl, b.py + b.pb, b.pz + b.ph), 0);
            NewScale := lTag * 1.2 / Abs(MaxP.x - MinP.x) * single(PgScale[CurPage]);
            if NewScale < Settings.Scale then
              Settings.Scale := NewScale;

            MinP := ScreenCoord(Point3D(b.px, b.py + b.pb, b.pz), 0);
            MaxP := ScreenCoord(Point3D(b.px + b.pl, b.py, b.pz + b.ph), 0);
            NewScale := lTag * 0.8 / Abs(MaxP.y - MinP.y) * single(PgScale[CurPage]);
            if NewScale < Settings.Scale then
              Settings.Scale := NewScale;

            MidP := ScreenCoord(Point3D(b.px + (b.pl div 2), b.py + (b.pb div 2), b.pz + (b.ph div 2)), 0);

            Settings.xBase := Max(1, (ListBox1.ClientWidth div 2) - MidP.x);
            Settings.yBase := Max(2, (lTag div 2) - MidP.y);
            { --------------------------------- }

            Transform([Point3D(0, 0, 0), Point3D(0, 0, 3),
              Point3D(0, 0, PFACTORZ)], Pts, 0);
            zx := Pts[1].x - Pts[0].x;
            zy := Pts[1].y - Pts[0].y;

            zx1 := Pts[2].x - Pts[0].x;
            zy1 := Pts[2].y - Pts[0].y;

            SetStudsIncrement;
            b.Draw(LBCanvas);
          finally
            b.Free;
            btnStuds.Down := sb;
            RecallTransform;
            DetailLevel := sLevel;
            WireFrame := sWF;
          end
        except
          ;
        end
      end;
      Canvas.Brush.Style := bsClear;
      s := Trim(Items[Index]);
      i := Pos('|', s);
      if (i > 0) then begin
        s := Copy(s, i + 1, 255);
        Canvas.Font.Color := clBlack;
      end
      else begin
        Canvas.Font.Color := clMaroon;
      end;
      Canvas.TextOut(1, 1, s);
      (Control as TListBox).Canvas.Draw(Rect.Left, Rect.Top, LstBmp);
    end
  finally
    LBCanvas.Free;
  end
end;

procedure TMainForm.ListBox1MeasureItem(Control: TWinControl; Index: Integer;
  var Height: Integer);
begin
  Height := Min(255, Control.Tag);
end;

procedure TMainForm.btnPrevPageClick(Sender: TObject);
begin
  SetCurrentPage(CurPage - 1);
end;

procedure TMainForm.btnNextPageClick(Sender: TObject);
begin
  SetCurrentPage(CurPage + 1);
end;

procedure TMainForm.btnRestoreViewClick(Sender: TObject);
begin
  InternalNoRedraw := True;
  try
    NoRedraw := True;
    RotX.Position := Settings.RotXPos;
    RotZ.Position := Settings.RotZPos;
    ScaleBar.Position := Settings.ScaleBarPos;
    OffsetX.Position := Settings.OffsetXPos;
    OffsetY.Position := Settings.OffsetYPos;
    btnStuds.Down := not Settings.StudsDown;
  finally
    InternalNoRedraw := False;
  end;
  RedrawPicture(Sender);
end;

procedure TMainForm.btnZoomInClick(Sender: TObject);
begin
  with ScaleBar do
    if Position > Min then
      Position := Position - SmallChange;
end;

procedure TMainForm.btnZoomOutClick(Sender: TObject);
begin
  with ScaleBar do
    if Position < Max then
      Position := Position + SmallChange;
end;

procedure TMainForm.mSafePosClick(Sender: TObject);
begin
  mSafePos.Checked := not mSafePos.Checked;
  SettingsSafe := mSafePos.Checked;
end;

procedure TMainForm.mSlowRenderClick(Sender: TObject);
begin
  mSlowRender.Checked := not mSlowRender.Checked;
  SettingsSlow := mSlowRender.Checked;
end;

procedure TMainForm.mRestBgClick(Sender: TObject);
begin
  BackGround.Free;
  BackGround := nil;
  BackGroundFile := '';
  Color := clBtnFace;
  RedrawPicture(Sender);
end;

procedure TMainForm.mHideStudsClick(Sender: TObject);
begin
  mHideStuds.Checked := not mHideStuds.Checked;
end;

procedure TMainForm.btnAboutClick(Sender: TObject);
begin
  About.ShowModal;
end;

procedure TMainForm.btnSavePicClick(Sender: TObject);
begin
  if btnSavePic.Down then
    Camera.State := [cmsActive]
  else
    Camera.State := [];
  DrawCamera;
end;

procedure TMainForm.SavePicture(const Quality: integer);
var
  s                 : string;
  e                 : string;
  bmp               : TBitMap;
  jpg               : TJPEGImage;
  png               : TPngObject;
  Size              : integer;
  SizeTxt           : string;
begin
  s := ExtractFileName(MyOpenDialog.FileName);
  e := ExtractFileExt(s);
  if Length(e) > 0 then begin
    s := Copy(s, 1, Length(s) - Length(e));
  end;
  dlgSavePicture.InitialDir := SaveBMPPath;
  dlgSavePicture.FileName := s;
  dlgSavePicture.Title := 'Save picture';

  if Quality = 0 then
    Size := Round((Camera.r.Bottom - Camera.r.Top + 1) * (Camera.r.Right - Camera.r.Left + 1) * 4)
  else
    Size := Round((Camera.r.Bottom - Camera.r.Top + 1) * Quality * (Camera.r.Right - Camera.r.Left + 1) * Quality * 4);

  if Size >= (1024 * 1024 * 100) then begin
    SizeTxt := 'MByte';
    Size := Round(Size / 1024 / 1024);
  end
  else if Size >= 1024 * 10 then begin
    SizeTxt := 'kByte';
    Size := Round(Size / 1024);
  end
  else begin
    SizeTxt := 'Byte';
  end;

  case Quality of
    0: dlgSavePicture.Title := Format('Save picture (.bmp size: %d %s)', [Size, SizeTxt]);
    1: dlgSavePicture.Title := Format('Save anti-aliased picture (.bmp size: %d %s)', [Size, SizeTxt]);
    2: dlgSavePicture.Title := Format('Save large picture (.bmp size: %d %s)', [Size, SizeTxt]);
    4: dlgSavePicture.Title := Format('Save quite large picture (.bmp size: %d %s)', [Size, SizeTxt]);
    8: dlgSavePicture.Title := Format('Save very large picture (.bmp size: %d %s)', [Size, SizeTxt]);
  end;

  if dlgSavePicture.Execute then begin
    bmp := TBitMap.Create;
    bmp.PixelFormat := pf32bit;         // AntiAlias needs pf32Bit!
    try
      case Quality of
        0: begin
            bmp.Height := Camera.r.Bottom - Camera.r.Top;
            bmp.Width := Camera.r.Right - Camera.r.Left;
            bmp.Canvas.CopyRect(Rect(0, 0, bmp.Width, bmp.Height),
              Shadow.Canvas, Camera.r);
          end;
        1: begin
            bmp.Height := Camera.r.Bottom - Camera.r.Top;
            bmp.Width := Camera.r.Right - Camera.r.Left;
            AntiAliasDraw(bmp, Camera.r, Shadow.Width, Shadow.Height);
          end;
        else begin
            bmp.Height := (Camera.r.Bottom - Camera.r.Top) * Quality;
            bmp.Width := (Camera.r.Right - Camera.r.Left) * Quality;
            LargeBmpDraw(bmp, Camera.r, Quality)
          end
      end;

      if Pos('.jpg', LowerCase(dlgSavePicture.FileName)) > 0 then begin
        jpg := TJPEGImage.Create;
        try
          jpg.GrayScale := False;
          jpg.Assign(bmp);
          jpg.SaveToFile(dlgSavePicture.FileName);
        finally
          jpg.Free;
        end
      end
      else if Pos('.png', LowerCase(dlgSavePicture.FileName)) > 0 then begin
        png := TPngObject.Create;
        try
          png.Assign(bmp);
          png.SaveToFile(dlgSavePicture.FileName);
        finally
          png.Free;
        end
      end
      else begin
        Bmp.SaveToFile(dlgSavePicture.FileName);
      end;
    finally
      bmp.Free;
    end;
    SaveBMPPath := ExtractFilePath(dlgSavePicture.FileName);
  end;
end;

procedure TMainForm.ListBox1MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  i                 : integer;
begin
  with ListBox1 do begin
    i := ItemAtPos(Point(x, y), True);
    ItemIndex := i;
  end;
end;

procedure TMainForm.pumEditPopup(Sender: TObject);
begin
  Editblock1.Enabled := False;
  Addnewblock1.Enabled := False;
  if (ListBox1.ItemIndex >= 0) then begin
    if TStringList(Pages.Objects[CurPage])[ListBox1.ItemIndex][1] <> 'M' then begin
      Editblock1.Enabled := (ComboBox1.ItemIndex > 0) and (ListBox1.ItemIndex >= 0);
      Addnewblock1.Enabled := (ComboBox1.ItemIndex > 0);
    end;
    Removeblock1.Enabled := (ComboBox1.ItemIndex > 0) and (ListBox1.ItemIndex >= 0);
    Addnewpage1.Enabled := True;
    RemovePage1.Enabled := (ComboBox1.ItemIndex > 0) and (TStringList(Pages.Objects[CurPage]).Count = 0);
    Customize1.Enabled := True;
    Properties1.Enabled := (ComboBox1.ItemIndex > 0);
  end
end;

procedure TMainForm.UpdateBC2LDList(Old, New: string);
var
  Modified          : Boolean;
begin
  InitializeLDrawCross;
  Modified := False;
  {}
  if Modified then begin
    SaveLDrawCross;
  end
end;

procedure TMainForm.Editblock1Click(Sender: TObject);
var
  dl                : integer;
  s0                : string;
begin
  if (ListBox1.ItemIndex >= 0) then begin
    dl := DetailLevel;
    s0 := TStringList(Pages.Objects[CurPage])[ListBox1.ItemIndex];
    AddHard.SetBlock(s0, False);
    AddHard.SetMode('Edit block', 'Replace');
    if (AddHard.ShowModal = mrOK) then begin
      TStringList(Pages.Objects[CurPage])[ListBox1.ItemIndex] := AddHard.CurrentBlock;
      PgHeight[CurPage] := Pointer(Max(integer(PgHeight[CurPage]), AddHard.ApproxHeight));
      SetCurrentPage(CurPage);
      RefreshListBox;
      {
        if AddHard.CurrentBlock ends in '|<ident>' then
          update bc2ld.lst
          - remove the line matching s0 (if any)
          - add a line matching AddHard.CurrentBlock
      }
      if Pos('|', AddHard.CurrentBlock) > 0 then begin
        UpdateBC2LDList(s0, AddHard.CurrentBlock);
      end
    end;
    DetailLevel := dl;
  end
end;

procedure TMainForm.AddNewBlock1Click(Sender: TObject);
var
  dl                : integer;
begin
  with ListBox1 do begin
    dl := DetailLevel;
    if ListBox1.ItemIndex >= 0 then
      AddHard.SetBlock(TStringList(Pages.Objects[CurPage])[ListBox1.ItemIndex], True);
    AddHard.SetMode('Add new block', 'Add');
    if (AddHard.ShowModal = mrOK) and
      (Length(AddHard.CurrentBlock) > 0) then begin
      { add new piece to current page }
      TStringList(Pages.Objects[CurPage]).Add(AddHard.CurrentBlock);
      PgHeight[CurPage] := Pointer(Max(integer(PgHeight[CurPage]), AddHard.ApproxHeight));
      SetCurrentPage(CurPage);
      RefreshListBox;
      {
        if AddHard.CurrentBlock ends in '|<ident>' then
          update bc2ld.lst
          - add a line matching AddHard.CurrentBlock
      }
    end;
    DetailLevel := dl;
  end;
end;

procedure TMainForm.Removeblock1Click(Sender: TObject);
begin
  with ListBox1 do begin
    if ItemIndex >= 0 then begin
      TStringList(Pages.Objects[CurPage]).Delete(ItemIndex);
      Items.Delete(ItemIndex);
    end;
  end;
end;

procedure TMainForm.miEditIDClick(Sender: TObject);
var
  s0                : string;
begin
  if (ListBox1.ItemIndex >= 0) then begin
    s0 := TStringList(Pages.Objects[CurPage])[ListBox1.ItemIndex];
    frmEditID.Text := s0;
    if (frmEditID.ShowModal = mrOK) then begin
      TStringList(Pages.Objects[CurPage])[ListBox1.ItemIndex] := frmEditID.Text;
      SetCurrentPage(CurPage);
      RefreshListBox;
      if Pos('|', frmEditID.Text) > 0 then begin
        UpdateBC2LDList(s0, frmEditID.Text);
      end
    end
  end
end;

procedure TMainForm.AddNewPage1Click(Sender: TObject);
var
  i                 : integer;
  d                 : single;
begin
  i := Pages.AddObject('', TStringList.Create);
  Pages[i] := Format('Page%d', [i]);
  PageNames.Add(Pages[i]);
  PgHeight.Add(Pointer(40));
  d := 0.5;
  PgScale.Add(Pointer(d));
  SetCurrentPage(i);
end;

procedure TMainForm.Removepage1Click(Sender: TObject);
begin
  TStringList(Pages.Objects[CurPage]).Free;
  Pages.Delete(CurPage);
  PageNames.Delete(CurPage + 1);
  PgHeight.Delete(CurPage);
  PgScale.Delete(CurPage);
  SetCurrentPage(CurPage);
end;

procedure TMainForm.FastStuds1Click(Sender: TObject);
begin
  NoStuds2.Checked := False;
  FastStuds2.Checked := False;
  BetterStuds2.Checked := False;
  BestStuds2.Checked := False;

  with Sender as TMenuItem do begin
    Checked := True;
    TBlock.SetStudQuality(Tag);
    btnStuds.Down := NoStuds2.Checked;
  end;
  RedrawPicture(nil);
end;

procedure TMainForm.btnColorDlgClick(Sender: TObject);
begin
  ColorDialog1.Color := ColorIndicator;
  if ColorDialog1.Execute then begin
    ClearCursorPiece;
    ColorIndicator := ColorDialog1.Color;
    if Assigned(Piece) then
      Piece.cl := ColorIndicator;
    RedrawCursorPiece;
    RefreshListBox;
  end;
end;

procedure TMainForm.Advancedtoolbox1Click(Sender: TObject);
begin
  AdvancedToolBox1.Checked := not AdvancedToolBox1.Checked;
  AdvOptions.Visible := AdvancedToolBox1.Checked;
end;

procedure TMainForm.NoDetailsClick(Sender: TObject);
begin
  WireFrame := False;
  btnWireFrame.Down := False;
  miNoDetail.Checked := False;
  miMoreDetail.Checked := False;
  miMostDetail.Checked := False;

  with (Sender as TMenuItem) do begin
    Checked := True;
    //    if Tag <> 3 then
    DetailLevel := Tag
      //    else begin
//      WireFrame := True;
//      btnWireFrame.Down := True;
//    end
  end;
  RedrawPicture(nil);
end;

function TMainForm.NextSelected(const b: integer): integer;
var
  i                 : integer;
begin
  Result := -1;
  for i := b + 1 to Pred(BlockList.Count) do begin
    if (TBlock(BlockList[i]).Selected) then begin
      Result := i;
      Exit;
    end
  end
end;

function TMainForm.FirstSelected: integer;
begin
  Result := NextSelected(0);
end;

procedure TMainForm.pumOptionsPopup(Sender: TObject);
var
  i                 : integer;
begin
  i := FirstSelected;
  if (i >= 0) then begin
    miGroup.Enabled := True;
    if (TBlock(BlockList[i]).Group > 0) then
      miBreak.Enabled := True;
  end
  else begin
    miGroup.Enabled := False;
    miBreak.Enabled := False;
  end
end;

procedure TMainForm.miGroupClick(Sender: TObject);
var
  i, j              : integer;
begin
  i := FirstSelected;
  j := NextSelected(i);
  if (i >= 0) and (j >= 0) then begin
    Inc(NextGroup);
    while (i >= 0) do begin
      TBlock(BlockList[i]).Group := NextGroup;
      TBlock(BlockList[i]).Selected := False;
      i := NextSelected(i);
    end
  end;
  RedrawPicture(nil);
end;

procedure TMainForm.miBreakClick(Sender: TObject);
var
  i                 : integer;
begin
  i := FirstSelected;
  while (i >= 0) do begin
    TBlock(BlockList[i]).Group := 0;
    TBlock(BlockList[i]).Selected := False;
    i := NextSelected(i);
  end;
  RedrawPicture(nil);
end;

procedure TMainForm.ComboBox1DropDown(Sender: TObject);
begin
  ComboBox1.Items.Assign(PageNames);
end;

procedure TMainForm.ComboBox1Change(Sender: TObject);
begin
  if (ComboBox1.ItemIndex = 0) then begin
    ListBox1.Tag := RcHeight;
    ListBox1.Items.Assign(Recent);
    ListBox1.SetFocus;
  end
  else
    SetCurrentPage(ComboBox1.ItemIndex - 1);
end;

procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  {}
end;

procedure TMainForm.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  CanClose := CheckModified;
end;

procedure TMainForm.Hints1Click(Sender: TObject);
begin
  Hints1.Checked := not Hints1.Checked;
  Application.ShowHint := Hints1.Checked;
end;

procedure TMainForm.miShadingClick(Sender: TObject);
begin
  miShading.Checked := not miShading.Checked;
  RedrawPicture(nil);
  ListBox1.Repaint;                     //Invalidate;
end;

procedure TMainForm.miAdjustLightClick(Sender: TObject);
begin
  if SetLight.Execute then begin
    CalcStandardShades;
    RedrawPicture(nil);
    RefreshListBox;
  end
end;

procedure TMainForm.Backgroundpicture1Click(Sender: TObject);
var
  pic               : TPicture;
begin
  BackGround.Free;
  BackGround := nil;
  BackGroundFile := '';
  OpenPictureDialog1.Filter := GraphicFilter(TGraphic);

  if OpenPictureDialog1.Execute then begin
    pic := TPicture.Create;
    try
      pic.LoadFromFile(OpenPictureDialog1.FileName);
      if pic.Graphic <> nil then begin
        BackGround := TBitMap.Create;
        BackGround.PixelFormat := BitDepth;
        BackGround.Height := pic.Height;
        BackGround.Width := pic.Width;
        BackGround.Canvas.Draw(0, 0, pic.Graphic);

        BackGroundFile := OpenPictureDialog1.FileName;
        LoadBGRPath := ExtractFilePath(BackGroundFile);
      end
    finally
      pic.Free;
    end;
  end;
  RedrawPicture(nil);
end;

procedure TMainForm.Reorderpages1Click(Sender: TObject);
begin
  frmReorder.Execute;
  SetCurrentPage(CurPage);
end;

procedure TMainForm.Customize1Click(Sender: TObject);
begin
  frmCustomize.Execute;
  SetCurrentPage(CurPage);
end;

procedure TMainForm.Properties1Click(Sender: TObject);
var
  Hdr               : string;
  Height            : integer;
  Scale             : single;
begin
  if (ComboBox1.ItemIndex > 0) then begin
    Hdr := PageNames[CurPage + 1];
    Height := integer(pgHeight[CurPage]);
    Scale := single(pgScale[CurPage]);
    frmProperties.Execute(Hdr, Height, Scale);
    if (PageNames[CurPage + 1] <> Hdr) or
      (pgHeight[CurPage] <> Pointer(Height)) or
      (pgScale[CurPage] <> Pointer(Scale)) then begin
      PageNames[CurPage + 1] := Hdr;
      pgHeight[CurPage] := Pointer(Height);
      pgScale[CurPage] := Pointer(Scale);
      SetCurrentPage(CurPage);
      ComboBox1.Text := Hdr;
    end
  end
end;

procedure TMainForm.FillPageFromFile(FileName: string; PageNo: integer);
var
  f                 : TextFile;
  s                 : string;
  i, j              : integer;
begin
  AssignFile(f, FileName);
  Reset(f);
  while not Eof(f) do begin
    ReadLn(f, s);
    i := Pos('[', s);
    if i > 0 then begin
      j := Pos(']', s);
      s := Copy(s, i + 1, j - i - 1);
      TStringList(Pages.Objects[PageNo]).Add(Format('G %s, %s',
        [ExtractFileName(FileName), s]));
    end
  end;
  CloseFile(f);
end;

procedure TMainForm.Addpagefromfile1Click(Sender: TObject);
begin
  OpenDialog2.InitialDir := ExeLib + 'parts';
  if Opendialog2.Execute then begin
    AddNewPage1Click(Sender);
    FillPageFromFile(Opendialog2.FileName, CurPage);
    SetCurrentPage(CurPage);
    RefreshListBox;
    Properties1Click(Sender);
  end;
end;

procedure TMainForm.cbResolutionChange(Sender: TObject);
begin
  Resolution := TResolution(cbResolution.ItemIndex);
  case Resolution of
    rNormal: begin
        ResXYFact := PFACTORXY;
        ResZFact := PFACTORZ div 3;
      end;
    rHalf: begin
        ResXYFact := PFACTORXY div 2;
        ResZFact := PFACTORZ div 3 div 2;
      end;
    rFine: begin
        ResXYFact := 1;
        ResZFact := 1;
      end;
  end;
  if Assigned(Cutting.Dlg) then
    Cutting.Dlg.UpdateIncrements;
end;

procedure TMainForm.PaintBox1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  Camera.State := Camera.State * [cmsActive];
  Screen.Cursor := crDefault;
  if miWfOnMouseRot.Checked then begin
    if swf <> btnWireFrame.Down then begin
      btnWireFrame.Down := swf;
      btnWireFrameClick(nil);
    end
  end
end;

procedure TMainForm.Addcombo1Click(Sender: TObject);
var
  i                 : integer;
  s                 : string;
begin
  MyOpenDialog.Title := 'Add combo part';
  MyOpenDialog.InitialDir := ExeLib + 'Combos';

  if MyOpenDialog.Execute then begin
    if (CurPage >= 0) then begin
      if Assigned(Pages.Objects[CurPage]) then begin
        with TStringList(Pages.Objects[CurPage]) do begin
          s := MyOpenDialog.FileName;
          i := Pos(AnsiUpperCase(ExeLib), AnsiUpperCase(s));
          if (i = 1) then
            s := Copy(s, Length(ExeLib) + 1, 255);
          i := Pos('.LGO', AnsiUpperCase(s));
          if (i > 0) then begin
            s := 'M ' + Copy(s, 1, i - 1);
            i := ListBox1.ItemIndex;
            if (i >= 0) then
              Insert(i, s)
            else
              Add(s);
            SetCurrentPage(CurPage);
          end
        end
      end
    end
  end
end;

procedure TMainForm.Nostuds1Click(Sender: TObject);
begin
  {}
end;

procedure TMainForm.RxPopupMenu1DrawItem(Sender: TMenu; Item: TMenuItem;
  Rect: TRect; State: TMenuOwnerDrawState);
begin
  {}
  Canvas.Textout(Rect.Left, Rect.Top, Item.Caption);
end;

procedure TMainForm.btnWireFrameClick(Sender: TObject);
const
  sb                : Boolean = False;
  sLevel            : integer = 0;
  sShade            : Boolean = True;
begin
  WireFrame := btnWireFrame.Down;
  if WireFrame then begin
    sb := btnStuds.Down;
    btnStuds.Down := True;
    sLevel := DetailLevel;
    DetailLevel := 0;
    sShade := miShading.Checked;
    miShading.Checked := False;
  end
  else begin
    btnStuds.Down := sb;
    DetailLevel := sLevel;
    miShading.Checked := sShade;
  end;
  RedrawPicture(nil);
end;

procedure TMainForm.miSeeThroughBPClick(Sender: TObject);
begin
  if Assigned(Sender) then
    with (Sender as TMenuItem) do begin
      Checked := not Checked;
      WireBase := Checked;
      RedrawPicture(nil);
    end
end;

procedure TMainForm.miWfOnMouseRotClick(Sender: TObject);
begin
  if Assigned(Sender) then
    with (Sender as TMenuItem) do begin
      Checked := not Checked;
    end
end;

procedure TMainForm.miAntiAliasClick(Sender: TObject);
var
  NewState          : Boolean;
begin
  NewState := not miAntiAlias.Checked;
  pfDevice1Click(pf32bit1);
  miAntiAlias.Checked := NewState;
  RedrawPicture(nil);
end;

var
  i                 : integer;

procedure TMainForm.Boundary1Click(Sender: TObject);
begin
  Cutting.Dlg.NotifyChange := CuttingDlgChange;
  if Cutting.Dlg.Visible then begin
    Cutting.Dlg.Hide;
    Boundary1.Checked := False;
  end
  else begin
    Cutting.Dlg.Show;
    Boundary1.Checked := True;
  end;
end;

procedure TMainForm.CuttingDlgChange(Sender: TObject);
begin
  if Cutting.Dlg.Visible then begin
    Boundary1.Checked := True;
  end
  else begin
    Boundary1.Checked := False;
  end;
end;

procedure TMainForm.miTimingClick(Sender: TObject);
begin
  miTiming.Checked := not miTiming.Checked;
end;

procedure TMainForm.pfdevice1Click(Sender: TObject);
begin
  miAntiAlias.Checked := False;
  with (Sender as TMenuItem) do begin
    SetBitDepth(Tag);
    Checked := True;
  end
end;

procedure TMainForm.SetBitDepth(Depth: integer);
begin
  case Depth of
    1: BitDepth := pf8Bit;
    2: BitDepth := pf16Bit;
    3: BitDepth := pf24Bit;
    4: BitDepth := pf32Bit;
    5: BitDepth := pfDevice;
    else
      Exit;
  end;
  Shadow.PixelFormat := BitDepth;
  LstBmp.PixelFormat := BitDepth;
  PaintBox1.Repaint;                    //Invalidate;
end;

procedure TMainForm.Sequencer1Click(Sender: TObject);
begin
  if frmSeq.Attached(Self) then begin
    Panel2.Visible := True;
    frmSeq.Detach;
  end
  else begin
    Panel2.Visible := False;
    frmSeq.Attach(Self);
  end
end;

procedure TMainForm.btnUndoClick(Sender: TObject);
begin
  // Undo
  BlockList.Undo;
  btnUndo.Enabled := BlockList.UndoCount > 0;
  btnRedo.Enabled := BlockList.RedoCount > 0;
  btnRefreshClick(nil);
end;

procedure TMainForm.btnRedoClick(Sender: TObject);
begin
  // Redo
  BlockList.Redo;
  btnUndo.Enabled := BlockList.UndoCount > 0;
  btnRedo.Enabled := BlockList.RedoCount > 0;
  btnRefreshClick(nil);
end;

procedure TMainForm.FormMouseWheelDown(Sender: TObject; Shift: TShiftState; MousePos: TPoint; var Handled: Boolean);
var
  TestRect          : TRect;
  Pt: TPoint;
begin
  TestRect.TopLeft := ClientToScreen(Panel3.BoundsRect.TopLeft);
  TestRect.BottomRight := ClientToScreen(Panel3.BoundsRect.BottomRight);
  if PtInRect(TestRect, MousePos) then begin
    btnZoomInClick(nil);
    if Assigned(Piece) then begin
      ClearCursorPiece;
      RedrawCursorPiece;
    end;
    Handled := True;
  end;
end;

procedure TMainForm.FormMouseWheelUp(Sender: TObject; Shift: TShiftState; MousePos: TPoint; var Handled: Boolean);
var
  TestRect          : TRect;
begin
  TestRect.TopLeft := ClientToScreen(Panel3.BoundsRect.TopLeft);
  TestRect.BottomRight := ClientToScreen(Panel3.BoundsRect.BottomRight);
  if PtInRect(TestRect, MousePos) then begin
    btnZoomOutClick(nil);
    if Assigned(Piece) then begin
      ClearCursorPiece;
      RedrawCursorPiece;
    end;
    Handled := True;
  end;
end;

initialization
  BitDepth := pf32bit;
  ExeLib := ExtractFilePath(Application.ExeName);
  Shadow := TBitMap.Create;
  Shadow.PixelFormat := BitDepth;

  WorkBmp := TBitMap.Create;
  WorkBmp.PixelFormat := pfDevice;
  LstBmp := TBitMap.Create;
  LstBmp.PixelFormat := BitDepth;

  BlockList := TBlockList.Create;
  MRUList := TStringList.Create;
  Application.UpdateFormatSettings := False; // 2.11
  DecimalSeparator := '.';

finalization
  Shadow.Free;
  WorkBmp.Free;
  LstBmp.Free;
  if Assigned(BlockList) then begin
    for i := 0 to Pred(BlockList.Count) do
      TObject(BlockList[i]).Free;
    BlockList.Free;
    BlockList := nil;
  end;
  if Assigned(LDrawCross) then begin
    for i := 0 to Pred(LDrawCross.Count) do
      TLDrawRecord(LDrawCross.Objects[i]).Free;
    LDrawCross.Free;
    LDrawCross := nil;
  end;
  MRUList.Free;
  MRUList := nil;
end.

